#pragma once
#include <Windows.h>
#include <assert.h>
#include <iostream>
#include <thread>
#include <chrono>
#include <conio.h>
#include <time.h>
#include <map>
#include <vector>
#include "Addresses_1.h"
#include "VMProtectSDK.h"

extern DWORD luaState = 0;

class LuaInst {
public:
	int LuaInstanceRef;
};

class Inst {
public:
	int InstanceRef;
};

#pragma warning(disable:4800)

/*--------------------*/

extern std::string rbxlua_getvalue(DWORD luaState, int idx, const char* k);
extern void rbxlua_pushnil(DWORD luaState);
extern int rbxlua_newthread(DWORD luaState);
//extern void rbxlua_pop(DWORD luaState, int n);
extern void rbxlua_pushbool(DWORD luaState, BOOL val);
extern void rbxlua_pushstring(DWORD luaState, const char *s);
extern int rbxlua_pcall(DWORD luaState, int nargs, int nresults, int errfunc);
extern int rbxlua_type(DWORD luaState, int idx, BOOL IsNil);
extern int _rbxlua_getservice(DWORD luaState, const char* ServiceName);
extern void rbxlua_pushnumber(DWORD luaState, double Number);
extern const char* rbxlua_tolstring(DWORD luaState, int idx, size_t *len);
extern void rbxlua_pushvalue(DWORD luaState, int idx);
extern void rbxlua_settop(DWORD luaState, int n);
extern int rbxlua_touserdata(DWORD luaState, int idx);
extern void rbxlua_setfield(DWORD luaState, int idx, const char *k);
extern BOOL rbxlua_toboolean(DWORD luaState, int idx);
extern void rbxlua_emptystack(DWORD luaState);
extern int rbxlua_getfield(DWORD luaState, int idx, const char *k);
//extern int rbxlua_newuserdata(DWORD luaState, size_t size);
extern int rbxlua_gettop(DWORD luaState);
extern void rbxlua_pushlstring(DWORD luaState, const char* a2, int a3);

extern int rbxWrapToLua(DWORD luaState, int InstRef);

///////////////////////

//extern void SetupVariables();
extern std::string HttpGet(std::string url);
//extern void LuaExecuteString(std::string Source);

//////////////////////

//DWORD luaState = 0;
//#define rbxlua_USE_APICHECK // 1337hax - still testing
#define rbxlua_REGISTRYINDEX       (-10000)
#define rbxlua_ENVIRONINDEX        (-10001)
#define rbxlua_GLOBALSINDEX        (-10002)
#define rbxlua_upvalueindex(i)     (rbxlua_GLOBALSINDEX-(i))
//#define l_pushcfunction(luaState,f) l_pushcclosure(luaState,f,0)

#define rbxlua_TNONE               (-1)
#define _rbxlua_TNIL				 0
#define rbxlua_TNUMBER				 2
#define rbxlua_TBOOLEAN				 3
#define rbxlua_TSTRING				 4
#define rbxlua_TLIGHTUSERDATA		 1
#define rbxlua_TTABLE				 7
#define rbxlua_TUSERDATA			 8
#define rbxlua_TFUNCTION			 6
#define rbxlua_TPROTO				 9
#define rbxlua_TTHREAD				 5
#define rbxlua_TUPVALUE				 10

//#define rbxlua_pop(L,n)            rbxlua_settop(L, -(n)-1)
//#define rbxlua_emptystack(L)       rbxlua_settop(L, 0)
#define rbxlua_isfunction(L,n)     (rbxlua_type(L, (n), FALSE) == rbxlua_TFUNCTION)
#define rbxlua_istable(L,n)        (rbxlua_type(L, (n), FALSE) == rbxlua_TTABLE)
#define rbxlua_islightuserdata(L,n)        (rbxlua_type(L, (n), FALSE) == rbxlua_TLIGHTUSERDATA)
#define rbxlua_isnil(L,n)			(rbxlua_type(L, (n), TRUE) == _rbxlua_TNIL)
#define rbxlua_isboolean(L,n)      (rbxlua_type(L, (n), FALSE) == rbxlua_TBOOLEAN)
#define rbxlua_isstring(L,n)      (rbxlua_type(L, (n), FALSE) == rbxlua_TSTRING)
#define rbxlua_isnumber(L,n)      (rbxlua_type(L, (n), FALSE) == rbxlua_TNUMBER)
#define rbxlua_isthread(L,n)       (rbxlua_type(L, (n), FALSE) == rbxlua_TTHREAD)
#define rbxlua_isnone(L,n)         (rbxlua_type(L, (n), TRUE) == rbxlua_TNONE)
#define rbxlua_isnoneornil(L, n)   (rbxlua_type(L, (n), TRUE) <= 0)

#define rbxlua_setglobal(L,s)      rbxlua_setfield(L, rbxlua_GLOBALSINDEX, (s))
#define rbxlua_getglobal(L,s)      rbxlua_getfield(L, rbxlua_GLOBALSINDEX, (s))
#define rbxlua_tostring(L,i)       rbxlua_tolstring(L, (i), NULL)
#define rbxlua_getservice(L,s)		_rbxlua_getservice(L, (s))

////
#define rbxlua_pushcfunction(L,f)	rbxlua_pushcclosure(L, (f), 0)
#define rbxlua_register(L,n,f)		(rbxlua_pushcfunction(L, (f)), rbxlua_setglobal(L, (n)))

#define rbxlua_pushliteral(L, s)	\
	rbxlua_pushlstring(L, "" s, (sizeof(s)/sizeof(char))-1)

/*
** compatibility macros and functions
*/
#define rbxlua_getregistry(L)	rbxlua_pushvalue(L, rbxlua_REGISTRYINDEX)

/*
** {======================================================================
** Debug API
** =======================================================================
*/

/*
** Event codes
*/
#define rbxlua_HOOKCALL	0
#define rbxlua_HOOKRET	1
#define rbxlua_HOOKLINE	2
#define rbxlua_HOOKCOUNT	3
#define rbxlua_HOOKTAILRET 4


/*
** Event masks
*/
#define rbxlua_MASKCALL	(1 << rbxlua_HOOKCALL)
#define rbxlua_MASKRET	(1 << rbxlua_HOOKRET)
#define rbxlua_MASKLINE	(1 << rbxlua_HOOKLINE)
#define rbxlua_MASKCOUNT	(1 << rbxlua_HOOKCOUNT)

////

typedef void* (__cdecl *rbxlua_GetField)(DWORD luaState, int idx, const char *k);
typedef int(__cdecl *rbxlua_PCall)(DWORD luaState, int nargs, int nresults, int errfunc);
typedef void(__cdecl *rbxlua_PushString)(DWORD luaState, const char *s);
typedef void(__cdecl *rbxlua_PushNumber)(DWORD luaState, double Number);
typedef const char *(__cdecl *rbxlua_ToLString)(DWORD luaState, int idx, size_t *len);
typedef void* (__cdecl *rbxlua_PushValue)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_GetTop)(DWORD luaState);
typedef void* (__cdecl *rbxlua_SetTop)(DWORD luaState, int n);
typedef void* (__cdecl *rbxlua_ToUserData)(DWORD luaState, int idx);
typedef void*(__cdecl *rbxlua_SetField)(DWORD luaState, int idx, const char *k);
//typedef void(*rbxlua_SetField)(int luaState, int index, const char *k);
typedef void* (__cdecl *rbxlua_PushCClosure)(DWORD luaState, int fn(), int n);
typedef BOOL(__cdecl *rbxlua_ToBoolean)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_Next)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_Type)(DWORD luaState, int idx);

//typedef int(__cdecl *rbxlua_pushcfunction)(DWORD luaState, int idx); // not correct args!!1
typedef int(__cdecl *rbxlua_Insert)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_Remove)(DWORD luaState, int idx);

typedef int(__cdecl *rbxlua_IsString)(DWORD luaState, int idx); // new

typedef int(__cdecl *rbxlua_Newthread)(DWORD luaState);
typedef int(*rbxlua_error)(DWORD luaState);
typedef void(*rbxlua_createtable)(DWORD luaState, int narr, int nrec);
typedef void(*rbxlua_pushlightuserdata)(DWORD luaState, void *p);
typedef int(__cdecl *rbxlua_Setmetatable)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_Newuserdata)(DWORD luaState, size_t size);
typedef void(*rbxlua_pushinteger)(DWORD luaState, ptrdiff_t n);
typedef double(__cdecl *rbxlua_ToNumber)(DWORD luaState, int idx);

typedef int(__cdecl *rbxlua_pushboolf)(DWORD luaState, int idx);


typedef int(__cdecl *rbxlua_Print)(int state, int* msginfo);

rbxlua_pushboolf _rbxlua_pushbool = (rbxlua_pushboolf)rbxaddy(0x545640); // 55 8B EC 8B 55 08 33 C0 39 45 0C

rbxlua_Newthread _rbxlua_newthread = (rbxlua_Newthread)rbxaddy(0x53BBB0); // "Executing lua from signal, execution de" should be 0x5300000 sub by the middle

rbxlua_ToNumber rbxlua_tonumber = (rbxlua_ToNumber)rbxaddy(0x5459C0);/*0x5465E0);/*0x5431A0);/*0x5411B0);/*0x540470);/*0x53D760);/*0x536900);/*0x534200);/*0x5348B0);/*0x534110;/*0x50EE90;/*0x517690;/*0x5180B0;
																	 /* Find "elapsedTime" & "ElapsedTime"
																	 follow the address inbetween them that looks like 'offset sub_NUMBERS'
																	 there should be 2 subs.. it should be the second one :)
																	 */

rbxlua_Print rbxlua_printf = (rbxlua_Print)rbxaddy(0x5067E0); // 2-22-16
															  //updated
rbxlua_PushString _rbxlua_pushstring = (rbxlua_PushString)rbxaddy(0x545A30);//0x546650);//0x543210);//0x541220);//0x5404E0);//0x53D7D0);//0x53E3C0);//0x53C2E0);//0x536C90);//0x536DC0);//0x536E10);//0x534270);//0x534AA0);//0x534920;//0x534180;//0x516F40;//0x517700;//0x518120;//0x518D60;//0x51C280;//0x51BA60;//0x53FE10; // "__tostring"
																			//updated
rbxlua_SetField _rbxlua_setfield = (rbxlua_SetField)rbxaddy(0x546100);/*0x546D20);/*0x5438E0);/*0x5418F0);/*0x540BB0);/*0x53DEA0);/*0x53EA90);/*0x53C9B0);/*0x537360);/*0x537490);/*0x5374E0);/*0x534940);/*0x535170);/*0x533EC0;/*0x534FF0;/*0x534850;/*0x517610;/*0x517DD0;/*0x5187F0;/*0x517D90;//0x519430;/*0x51C950;//
																	  Find "Failed to create Lua state"
																	  //go below to repeated subs and it should look like:
																	  /* // sub_51C950 is the setfield
																	  sub_51C950(v5, -10002, "delay");
																	  sub_51BEF0(v5, sub_508FF0, 0);
																	  sub_51C950(v5, -10002, "Delay");
																	  sub_51BEF0(v5, sub_51A6B0, 0);
																	  sub_51C950(v5, -10002, "ypcall");
																	  sub_51BEF0(v5, sub_51A6B0, 0);
																	  */
																	  /*0x51C950;/*0x51C130;/*0x5404E0;		/*0x53BDA0;
																	  The 'call sub_NUMBERS' right under "wait" AKA aWait; // OLD METHOD


																	  //updated												*/
rbxlua_PushNumber _rbxlua_pushnumber = (rbxlua_PushNumber)rbxaddy(0x5459C0);/*0x5465E0);/*0x5431A0);/*0x5411B0);/*0x540470);/*0x53D760);/*0x53E350);/*0x53C270);/*0x536C20);/*0x536D50);/*0x536DA0);/*0x534200);/*0x534A30);/*0x5348B0;/*0x534110;/*0x516ED0;/*0x517690;/*0x5180B0;/*0x518CF0;/*0x51C210;/*0x51C210;/*0x53FDA0;/*0x53FE50
																			At the very bottom of the string "math" AKA aMath and ontop of "pi" or aPi;
																			//updated												 */
rbxlua_PCall _rbxlua_pcall = (rbxlua_PCall)rbxaddy(0x545590);/*0x5461B0);/*0x542D60);/*0x540D80);/*0x540040);/*0x53D330);/*0x53DF20);/*0x53BE40);/*0x5367F0);/*0x536920);/*0x536970);/*0x533DB0);/*0x534600);/*0x534480;/*0x533CE0;/*0x516AA0;/*0x517260;/*0x517C80;/*0x5188C0;/*0x51BDE0;/*0x51B5C0;/*0x53F970;/*0x5388B0;
															 Find "Breakpoint %d condition runtime error: " AKA aBreakpointDC_0;
															 The first sub_NUMBERS in that function will be pcall;
															 */
															 //updated
rbxlua_ToLString _rbxlua_tolstring = (rbxlua_ToLString)rbxaddy(0x546570);/*0x5471A0);/*0x543D50);/*0x541D60);/*0x541020);/*0x53E310);/*0x53EF00);/*0x53CE20);/*0x5377D0);/*0x537900);/*0x537950);/*0x534DB0);/*0x5355E0);/*0x535460;/*0x534CC0;/*0x517A80;/*0x518240;/*0x518C60;/*0x5198A0;/*0x51CDC0;/*0x51C5A0;/*0x532450;		/*0x53C150;
																		 Find "!handler.empty()" AKA aHandler_empty;
																		 And follow the 'jnz short loc_NUMBERS' right under the emptyhandler;
																		 And find the first sub_NUMBERS and your done!1;
																		 */
																		 //updated// newproxy only supports the arguments ni
rbxlua_SetTop _rbxlua_settop = (rbxlua_SetTop)rbxaddy(0x546390);/*0x546FC0);/*0x543B70);/*0x541B80);/*0x540E40);/*0x53E130);/*0x53ED20);/*0x53CC40);/*0x5375F0);/*0x537720);/*0x537770);/*0x533810);/*0x535280;/*0x533EE0;/*0x533740;/*0x516500;/*0x516CC0;/*0x5176E0;/*0x518320;/*0x51/B840;/*0x51B020;/*0x540770;/*0x53F3D0;				/*0x53BFB0;
																Find "top+1 == rbxlua_gettop(functionThread)" AKA aTop1rbxlua_gettop;
																And the first sub_NUMBERS on the function is the address;
																*/
																//updated
rbxlua_ToBoolean _rbxlua_toboolean = (rbxlua_ToBoolean)rbxaddy(0x5464F0);/*0x547120);/*0x543CD0);/*0x541CE0);/*0x540FA0);/*0x53E290);/*0x53EE80);/*0x53CDA0);/*0x537750);/*0x537880);/*0x5378D0);/*0x534D30);/*0x5353E0);/*0x534C40;/*0x517A00;/*0x5181C0;/*0x518BE0;/*0x519820;/*0x51CD40;/*0x51C520;/*0x5408D0;		/*0x53C0D0;
																		 Find "isdst" AKA aIsdst;
																		 And follow the 'jnz short loc_NUMBERS' in the function;
																		 And it will be the sub_NUMBERS in the function;
																		 [normally right under the aIsdst function];
																		 //updated													*/
rbxlua_Type _rbxlua_type = (rbxlua_Type)rbxaddy(0x5468E0);/*0x547510);/*0x5440C0);/*0x5420D0);/*0x541390);/*0x53E680);/*0x53F270);/*0x53D190);/*0x537B40);/*0x537C70);/*0x537CC0);/*0x535120);/*0x535950);/*0x5357D0;/*0x535030;/*0x517DF0;/*0x5185B0;/*0x518FD0;/*0x519C10;/*0x51D130;/*0x51C910;/*0x540CC0;						/*0x53C440;
														  Find "rbxlua_isthread(functionThread, -1)" AKA arbxlua_isthreadFu;
														  It will be the first sub_NUMBERS in the function;
														  //updated													*/
rbxlua_GetField _rbxlua_getfield = (rbxlua_GetField)rbxaddy(0x544E50);/*0x545A70);/*0x542620);/*0x540640);/*0x53F900);/*0x53CBF0);/*0x53D7E0);/*0x53B700);/*0x5360B0);/*0x5361E0);/*0x536230);/*0x533670);/*0x533EC0);/*0x533D40;/*0x5335A0;/*0x516360;/*0x516B20;/*0x517540;/*0x518180;/*0x518180;/*0x51B6A0;/*0x51D130;/*0x51B6A0;/*0x51B6A0;/*0x51AE80;/*0x53F230;		/*0x53AE70;
																	  Find "__unm" AKA a__unm [it should say offset to the left of a_unm];
																	  Follow the 'offset sub_NUMBERS' right underneath it;
																	  Follow the last loc_NUMBERS in the function;
																	  It should be the first sub_NUMBERS;
																	  //updated													*/
rbxlua_PushValue _rbxlua_pushvalue = (rbxlua_PushValue)rbxaddy(0x545B20);/*0x546740);/*0x543300);/*0x541310);/*0x5405D0);/*0x53D8C0);/*0x53E4B0);/*0x53C3D0);/*0x536D80);/*0x536EB0);/*0x536F00);/*0x534360);/*0x534B90);/*0x534A10;/*0x534270;/*0x517030;/*0x5177F0;/*0x518210;/*0x518E50;/*0x51C370;/*0x51CB70;/*0x572700;/*0x51BB50;/*0x53FF00;		/*0x53B8D0;
																		 Find "%s.%s" AKA aS_S;
																		 In the function look for 'jz short loc_NUMBERS' and follow it;
																		 And it should be the second to last 'call sub_NUMBERS' in the function;
																		 //updated													*/
rbxlua_GetTop _rbxlua_gettop = (rbxlua_GetTop)rbxaddy(0x544FF0);/*0x545C10);/*0x5427C0);/*0x5407E0);/*0x53FAA0);/*0x53CD90);/*0x53D980);/*0x53B8A0);/*0x536250);/*0x536380);/*0x5363D0);/*0x533810);/*0x534060);/*0x533EE0;/*0x533740;/*0x516500;/*0x516CC0;/*0x5176E0;/*0x518320;/*0x51B840;/*0x51B020;/*0x53F3D0;				/*0x53AFB0;
																Find "tostring" AKA aTostring;
																It will be right on top of the "offset aTostring ; "tostring"";
																*/
rbxlua_ToUserData _rbxlua_touserdata = (rbxlua_ToUserData)rbxaddy(0x5468B0);/*0x5474E0);/*0x544090);/*0x5420A0);/*0x541360);/*0x53E650);/*0x53F240);/*0x53D160);/*0x537B10);/*0x537C40);/*0x5357A0);/*0x517DC0;/*0x518580;/*0x518FA0;/*0x519BE0;/*0x51D100;/*0x51C8E0;/*0x540C90;		/*0x53C410;
																			Find "Bad argument materials[%d][%d][%d] to '" AKA aBadArgumentM_0;
																			Should be the 3rd sub_NUMBERS in the function;
																			[and the 1st and 2nd should possibly be the same]
																			*/
rbxlua_Next rbxlua_next = (rbxlua_Next)rbxaddy(0x5366C0);

rbxlua_PushCClosure rbxlua_pushcclosure = (rbxlua_PushCClosure)rbxaddy(0x5456A0);
rbxlua_Insert rbxlua_insert = (rbxlua_Insert)rbxaddy(0x5337F0);
rbxlua_Remove rbxlua_remove = (rbxlua_Remove)rbxaddy(0x534610);

rbxlua_Setmetatable rbxlua_setmetatable = (rbxlua_Setmetatable)rbxaddy(0x5461C0);

rbxlua_Newuserdata rbxlua_newuserdata = (rbxlua_Newuserdata)rbxaddy(0x5453C0);
/*
Search "Width" and it should be the top one, follow it. And sub_533B10 is it!! That is newuserdata!!
.text:00751117 loc_751117:                             ; CODE XREF: .text:00751110j
.text:00751117                 test    eax, eax
.text:00751119                 jnz     short loc_751157
.text:0075111B                 mov     eax, [ebp+8]
.text:0075111E                 mov     esi, [ebp+10h]
.text:00751121                 movss   xmm0, dword ptr [eax+8]
.text:00751126                 movss   dword ptr [ebp-8], xmm0
.text:0075112B                 movss   xmm0, dword ptr [eax+0Ch]
.text:00751130                 push    8
.text:00751132                 push    esi
.text:00751133                 movss   dword ptr [ebp-4], xmm0
.text:00751138                 call    sub_533B10 // IT'S HERE!! IT'S HERE!!!!!!!!!!!!
.text:0075113D                 add     esp, 8
.text:00751140                 test    eax, eax
.text:00751142                 jz      short loc_7510C5
.text:00751144                 movss   xmm0, dword ptr [ebp-8]
.text:00751149                 movss   dword ptr [eax], xmm0
.text:0075114D                 movss   xmm0, dword ptr [ebp-4]
.text:00751152                 jmp     loc_7510C0
.text:00751157 ; ---------------------------------------------------------------------------
.text:00751157
.text:00751157 loc_751157:                             ; CODE XREF: .text:00751119j
.text:00751157                 mov     ecx, offset aWidth ; "Width"
.text:0075115C                 mov     eax, esi
.text:0075115E                 mov     edi, edi
*/
/*
static int l_cppfunction(lua_State *L) {
double arg = luaL_checknumber(L, 1);
lua_pushnumber(L, arg * 0.5);
return 1;
}
*/
int stackSize() { return rbxlua_gettop(luaState); }
void checkStack() { assert(rbxlua_gettop(luaState) <= 20); }
bool hasIndex(int index) {
	return (stackSize() >= (index < 0 ? -index : index) && index != 0);
}
void clearStack() {
	int size = stackSize();
	if (size > 0) {
		rbxlua_settop(luaState, 0); Sleep(50);//-(size)-1); Sleep(50);
	}
}

void rbxpushinst(DWORD s, int inst) { // not tested.. address is from 4-12-2016
	((void(__cdecl*)(int, int, int))0x52B8D0)(s, *(DWORD*)inst, 0);
}

void rbxlua_gettable(DWORD a1, int a2) {
	int v2 = ((int(__cdecl*)(int, int))0x533560)(a1, a2); // same as settable
	((int(__cdecl*)(int, int, int, int))0x786690)(a1, v2, *(DWORD *)(a1 + 16) - 16, *(DWORD *)(a1 + 16) - 16); //0x784320 // Find "loop in gettable"; and the addr is the function
}

void rbxlua_settable(DWORD a1, int a2) {
	int v2 = a1;
	int v3 = ((int(__cdecl*)(int, int))0x535A00)(a1, a2); //0x532DC0// inside rbxlua_getfield it is the v3 sub that looks like this: v3 = sub_533560(a1, a2);
	((int(__cdecl*)(int, int, int, int))0x798BC0)(v2, v3, *(DWORD *)(v2 + 16) - 32, *(DWORD *)(v2 + 16) - 16); //0x784490// Find "Attempt to modify a readonly table" and it should be the last result sub_NUMBERS and might start with a 7
	*(DWORD *)(v2 + 16) -= 32;
}

void _rbxlua_pushnil(DWORD luaState) { // rbxlua_pushnil
	__try {
		*(DWORD*)(*(DWORD *)(luaState + 16) + 8) = 0;
		*(DWORD*)(luaState + 16) += 16;
	}
	__except (EXCEPTION_EXECUTE_HANDLER) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 1", "", 0); Sleep(1);
	}
}

void rbxsetfield(DWORD s, int k, const char* n) {
	rbxlua_pushstring(s, n);
	rbxlua_pushvalue(s, -2);
	rbxlua_settable(s, k);
	//rbxlua_pop(s, -1);
}

void rbxlua_pushnil(DWORD luaState) {
	try {
		_rbxlua_pushnil(luaState);
	}
	catch (std::exception& e) {
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 2", "", 0);
	}
}

int rbxlua_touserdata(DWORD luaState, int idx) {
	int data = 0;
	try {
		data = *(int*)_rbxlua_touserdata(luaState, -1);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 3", "", 0);
	}
	return data;
}

int _rbxlua_getservice(DWORD luaState, const char* ServiceName) { // custom function // -5 or -6
	if (ServiceName != "") {
		rbxlua_getglobal(luaState, ServiceName);
		if (rbxlua_isnil(luaState, -1)) { // no '!' at the start since we are checking to make sure it's nil
			rbxlua_getglobal(luaState, "game");
			if (!rbxlua_isnil(luaState, -1)) {
				rbxlua_getfield(luaState, -1, "GetService");
				if (rbxlua_isfunction(luaState, -1)) {
					rbxlua_pushvalue(luaState, -2);
					rbxlua_pushstring(luaState, ServiceName);
					rbxlua_pcall(luaState, 2, 1, 0);
					if (!rbxlua_isnil(luaState, -1)) {
						rbxlua_setglobal(luaState, ServiceName);
						rbxlua_getglobal(luaState, ServiceName);
						return 1;
					}
					else {
						return 0;
						clearStack();
					}
				}
				else {
					clearStack();
					return 0;
				}
			}
		}
		else {
			return 1;
		}
	}
	return 0;
}

int rbxlua_getobject(DWORD luaState, int idx) {
	return (int)rbxlua_touserdata(luaState, idx);
}

// pushbool: use pushnumber 1 to push a true boolean, use pushnil to push false

/*void rbxlua_pushbool(DWORD luaState, int a2) {
	__try {
		int v2 = *(DWORD*)(luaState + 16);
		*(DWORD*)(v2 + 8) = 3;
		*(DWORD*)v2 = a2 != 0;
		*(DWORD*)(luaState + 16) += 16;
	}
	__except (EXCEPTION_EXECUTE_HANDLER) {
		Sleep(1);
	}
}*/

void rbxlua_pushbool(DWORD luaState, BOOL val) { // custom function
	try {
		_rbxlua_pushbool(luaState, val);
	}
	catch (std::exception) {}
	catch (...) {}
	/*if (val == TRUE) {
		rbxlua_pushnumber(luaState, 1);
	}
	else if (val == FALSE) {
		rbxlua_pushnil(luaState);
	}*/
}

int rbxlua_pcall(DWORD luaState, int nargs, int nresults, int errfunc) {
	int start = 0;
	try {
		start = _rbxlua_pcall(luaState, nargs, nresults, errfunc);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 4", "", 0);
	}
	return start;
}
/*
int rbxlua_isnil(DWORD luaState, int idx) {
try {
if (rbxlua_type(luaState, (idx)) == Rrbxlua_TNIL) {
return 1;
}
else {
return 0;
}
//ret = new int(_rbxlua_type(luaState, idx));
}
catch (std::exception& e) {
return 1;
MessageBoxA(0, e.what(), "", 0);
}
catch (...) {
return 1;
MessageBoxA(0, "A unexpected error has occured!", "", 0);
}
return 1;
}
*/
/*
int rbxlua_newuserdata(DWORD luaState, size_t size) {
try {
_rbxlua_newuserdata(luaState, size);
}
catch (std::exception& e) {
MessageBoxA(0, e.what(), "", 0);
}
catch (...) {
MessageBoxA(0, "A unexpected error has occured! ERROR#: 6", "", 0);
}
}
*/

int rbxlua_newthread(DWORD luaState) {
	try {
		return _rbxlua_newthread(luaState);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
		return 0;
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: newthread", "", 0);
		return 0;
	}
	return 0;
}

int rbxlua_type(DWORD luaState, int idx, BOOL IsNil) { // custom function
	int ret;
	//luaL_checktype(L, 2, LUA_TTABLE);
	try {
		ret = _rbxlua_type(luaState, idx);
	}
	catch (std::exception& e) {
		//clearStack();
		if (IsNil == TRUE) { // luaL_checktype(luaState, idx, _rbxlua_TNIL);
			ret = luaState;
		}
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		if (IsNil == TRUE) {
			ret = luaState;
		}
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 5", "", 0);
	}
	return ret;
}

std::string rbxlua_getvalue(DWORD luaState, int idx, const char* k) { // custom function
	std::string val;
	rbxlua_getfield(luaState, idx, k);
	val = rbxlua_tostring(luaState, idx);
	return val;
}

void rbxlua_pushstring(DWORD luaState, const char *s) {
	try {
		//rbxlua_pushlstring(luaState, s, strlen(s));
		_rbxlua_pushstring(luaState, s);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 6", "", 0);
	}
}

void rbxlua_pushnumber(DWORD luaState, double Number) {
	try {
		_rbxlua_pushnumber(luaState, double(Number));
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 7", "", 0);
	}
}
const char* rbxlua_tolstring(DWORD luaState, int idx, size_t *len) {
	//const char** ret;
	const char* ret;
	try {
		ret = _rbxlua_tolstring(luaState, idx, len);
		//ret = new const char*(_rbxlua_tolstring(luaState, idx, len));
	}
	catch (std::exception& e) {
		//clearStack();
		//free(&ret);
		MessageBoxA(0, e.what(), "", 0);
		return (const char*)"Failed to grab error!";
	}
	catch (...) {
		//clearStack();
		//free(&ret);
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 8", "", 0);
	}
	return ret;//*ret;
}

void rbxlua_pushlstring(DWORD luaState, const char* a2, int a3) {
	__try {
		if (*(DWORD *)(*(DWORD *)(luaState + 8) + luaState + 96) >= *(DWORD *)(*(DWORD *)(luaState + 8) + luaState + 84))
			((void(__cdecl*)(DWORD))0x7945B0)(luaState);
		int v3 = *(DWORD *)(luaState + 16);
		*(DWORD *)v3 = ((int(__cdecl*)(DWORD, const char*, int))0x538490)(luaState, a2, a3);
		*(DWORD *)(v3 + 8) = 4;
		*(DWORD *)(luaState + 16) += 16;
	}
	__except (EXCEPTION_EXECUTE_HANDLER) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: pushlstring", "", 0); Sleep(1);
	}
}

void rbxlua_pushvalue(DWORD luaState, int idx) {
	try {
		_rbxlua_pushvalue(luaState, idx);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 9", "", 0);
	}
}

void rbxlua_settop(DWORD luaState, int a2) {
	int i = 0;
	if (a2 < 0) {
		__try {
			*(DWORD *)(luaState + 16) += 16 * a2 + 16;
		}
		__except (EXCEPTION_EXECUTE_HANDLER) {
			Sleep(1);
		}
		rbxlua_pcall(luaState, 0, 0, 0);
	}
	else {
		__try {
			for (i = 16 * a2; *(DWORD *)(luaState + 16) < (unsigned int)(i + *(DWORD *)(luaState + 28)); *(DWORD *)(luaState + 16) += 16)
				*(DWORD *)(*(DWORD *)(luaState + 16) + 8) = 0;
			*(DWORD *)(luaState + 16) = i + *(DWORD *)(luaState + 28);
		}
		__except (EXCEPTION_EXECUTE_HANDLER) {
			Sleep(1);
		}
		rbxlua_pcall(luaState, 0, 0, 0);
	}
}

/*void rbxlua_settop(DWORD luaState, int n) {
try {
_rbxlua_settop(luaState, n);
}
catch (std::exception& e) {
clearStack();
MessageBoxA(0, e.what(), "ERROR", 0);
}
catch (...) {
clearStack();
//MessageBoxA(0, "A unexpected error has occured! ERROR#: 10", "", 0); Sleep(25);
}
}*/

/*void rbxlua_setfield(DWORD luaState, int k, const char* n) {
rbxlua_pushstring(luaState, n);
rbxlua_pushvalue(luaState, -2);
rbxlua_settable(luaState, k);
rbxlua_pop(luaState, -1);
}*/

void rbxlua_setfield(DWORD luaState, int idx, const char *k) {
	try {
		_rbxlua_setfield(luaState, idx, k);
		//((void*(__cdecl*)(int, int, const char*))0x535170)(luaState, idx, k);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "ERROR", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 11", "", 0); Sleep(25);
	}
}

BOOL rbxlua_toboolean(DWORD luaState, int idx) {
	try {
		return _rbxlua_toboolean(luaState, idx);
	}
	catch (std::exception& e) {
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 12", "", 0);
	}
	return NULL;
}

void rbxlua_emptystack(DWORD luaState) {
	try {
		rbxlua_settop(luaState, 0);
	}
	catch (std::exception& e) {
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 13", "", 0);
	}
}

void rbxlua_pop(DWORD luaState, int n) {
	try {
		_rbxlua_settop(luaState, -(n)-1);
	}
	catch (std::exception& e) {
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 14", "", 0);
	}
}

int rbxlua_getfield(DWORD luaState, int idx, const char *k) {
	try {
		_rbxlua_getfield(luaState, idx, k);
	}
	catch (std::exception) {//& e) {
							//clearStack();
							//MessageBoxA(0, e.what(), "getfield", 0);
							//_rbxlua_getfield(luaState, rbxlua_GLOBALSINDEX, "game");
		return 1;
	}
	catch (...) {
		//clearStack();
		//MessageBoxA(0, "A unexpected error has occured! ERROR#: 15", "", 0);
		//luaL_error(L, "We've run into an error! ERROR CODE: 0x15");
		return 1;
	}
	return 0;
}

/*int rbxlua_gettop(DWORD luaState) {
try {
return (*(DWORD*)(luaState + 16) - *(DWORD*)(luaState + 28)) >> 4;//_rbxlua_gettop(luaState);
}
catch (std::exception& e) {
MessageBoxA(0, e.what(), "", 0);
}
catch (std::invalid_argument e) {
MessageBoxA(0, e.what(), "Invalid argument!", 0);
}
catch (...) {
MessageBoxA(0, "A unexpected error has occured! ERROR#: 16", "", 0);
}
return 0;
}*/

int rbxlua_gettop(DWORD luaState) {
	int top = 0;
	__try {
		top = (*(DWORD*)(luaState + 16) - *(DWORD*)(luaState + 28)) >> 4;
	}
	__except (EXCEPTION_EXECUTE_HANDLER) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: rbxlua_gettop", "", 0); Sleep(1);
	}
	return top;
}

std::string HttpGet(std::string URL) {
	rbxlua_getglobal(luaState, "game");
	if (!rbxlua_isnil(luaState, -1)) {
		rbxlua_getfield(luaState, -1, "HttpGet");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushstring(luaState, URL.c_str());
		rbxlua_pushbool(luaState, 1);
		rbxlua_pcall(luaState, 3, 1, 0); Sleep(50);

		std::string returnval = rbxlua_tostring(luaState, -1);
		return returnval;
	}
	return *(std::string*)"";
}

void LoadGame(std::string URL) {
	rbxlua_getglobal(luaState, "game");
	if (!rbxlua_isnil(luaState, -1)) {
		std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=") + std::string(URL);
		rbxlua_getfield(luaState, -1, "Load");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushstring(luaState, FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}
}

void LoadInAsset(std::string URL) {
	rbxlua_getservice(luaState, "InsertService");
	if (!rbxlua_isnil(luaState, -1)) {
		std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=");
		rbxlua_getfield(luaState, -1, "SetAssetUrl");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushstring(luaState, FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}

	rbxlua_getservice(luaState, "InsertService");
	if (!rbxlua_isnil(luaState, -1)) {
		//std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=") + std::string(URL);
		rbxlua_getfield(luaState, -1, "SetTrustLevel");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushnumber(luaState, 255);
		//rbxlua_pushstring(luaState, URL.c_str());//FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}

	rbxlua_getservice(luaState, "InsertService");
	if (!rbxlua_isnil(luaState, -1)) {
		//std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=") + std::string(URL);
		rbxlua_getfield(luaState, -1, "ApproveAssetId");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushnumber(luaState, std::stoi(URL));
		//rbxlua_pushstring(luaState, URL.c_str());//FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}

	rbxlua_getservice(luaState, "InsertService");
	if (!rbxlua_isnil(luaState, -1)) {
		//std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=") + std::string(URL);
		rbxlua_getfield(luaState, -1, "LoadAsset");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushnumber(luaState, std::stoi(URL));
		//rbxlua_pushstring(luaState, URL.c_str());//FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}
}
