#pragma once
#include <Windows.h>
#include <assert.h>
#include <iostream>
#include <thread>
#include <chrono>
#include <conio.h>
#include <time.h>
#include <map>
#include <vector>
#include "Addresses_1.h"
#include "VMProtectSDK.h"
/*
#include "Vector3.h"
#include "Color3.h"
#include "UDim2.h"
#include "NumberRange.h"
#include "CFrame.h"
/*
extern "C" {
#include "lua.h"
#include "lauxlib.h"
#include "luaconf.h"
#include "lualib.h"
}*/

extern DWORD luaState = 0;
extern lua_State* XYZ_State = nullptr;

class LuaInst {
public:
	int LuaInstanceRef;
};

class Inst {
public:
	int InstanceRef;
};

struct ThreadParams {
	lua_State* lThread;
	int fRef;
	int Time;
};

#pragma warning(disable:4800)

/*--------------------*/

extern std::string rbxlua_getvalue(DWORD luaState, int idx, const char* k);
extern void rbxlua_pushnil(DWORD luaState);
extern int rbxlua_newthread(DWORD luaState);
//extern void rbxlua_pop(DWORD luaState, int n);
extern void rbxlua_pushbool(DWORD luaState, BOOL val);
extern void rbxlua_pushstring(DWORD luaState, const char *s);
extern int rbxlua_pcall(DWORD luaState, int nargs, int nresults, int errfunc);
extern int rbxlua_type(DWORD luaState, int idx, BOOL IsNil);
extern int _rbxlua_getservice(DWORD luaState, const char* ServiceName);
extern void rbxlua_pushnumber(DWORD luaState, double Number);
extern const char* rbxlua_tolstring(DWORD luaState, int idx, size_t *len);
extern void rbxlua_pushvalue(DWORD luaState, int idx);
extern void rbxlua_settop(DWORD luaState, int n);
extern int rbxlua_touserdata(DWORD luaState, int idx);
extern void rbxlua_setfield(DWORD luaState, int idx, const char *k);
extern BOOL rbxlua_toboolean(DWORD luaState, int idx);
extern void rbxlua_emptystack(DWORD luaState);
extern int rbxlua_getfield(DWORD luaState, int idx, const char *k);
//extern int rbxlua_newuserdata(DWORD luaState, size_t size);
extern int rbxlua_gettop(DWORD luaState);
extern void rbxlua_pushlstring(DWORD luaState, const char* a2, int a3);

extern int rbxWrapToLua(DWORD luaState, int InstRef);

///////////////////////

//extern void SetupVariables();
extern std::string HttpGet(std::string url);
extern void LuaExecuteString(std::string Source);

//////////////////////

//DWORD luaState = 0;
//#define rbxlua_USE_APICHECK // 1337hax - still testing
#define rbxlua_REGISTRYINDEX       (-10000)
#define rbxlua_ENVIRONINDEX        (-10001)
#define rbxlua_GLOBALSINDEX        (-10002)
#define rbxlua_upvalueindex(i)     (rbxlua_GLOBALSINDEX-(i))
//#define l_pushcfunction(luaState,f) l_pushcclosure(luaState,f,0)

#define rbxlua_TNONE               (-1)
#define _rbxlua_TNIL				 0
#define rbxlua_TNUMBER				 2
#define rbxlua_TBOOLEAN				 3
#define rbxlua_TSTRING				 4
#define rbxlua_TLIGHTUSERDATA		 1
#define rbxlua_TTABLE				 7
#define rbxlua_TUSERDATA			 8
#define rbxlua_TFUNCTION			 6
#define rbxlua_TPROTO				 9
#define rbxlua_TTHREAD				 5
#define rbxlua_TUPVALUE				 10

//#define rbxlua_pop(L,n)            rbxlua_settop(L, -(n)-1)
//#define rbxlua_emptystack(L)       rbxlua_settop(L, 0)
#define rbxlua_isfunction(L,n)     (rbxlua_type(L, (n), FALSE) == rbxlua_TFUNCTION)
#define rbxlua_istable(L,n)        (rbxlua_type(L, (n), FALSE) == rbxlua_TTABLE)
#define rbxlua_islightuserdata(L,n)        (rbxlua_type(L, (n), FALSE) == rbxlua_TLIGHTUSERDATA)
#define rbxlua_isnil(L,n)			(rbxlua_type(L, (n), TRUE) == _rbxlua_TNIL)
#define rbxlua_isboolean(L,n)      (rbxlua_type(L, (n), FALSE) == rbxlua_TBOOLEAN)
#define rbxlua_isstring(L,n)      (rbxlua_type(L, (n), FALSE) == rbxlua_TSTRING)
#define rbxlua_isnumber(L,n)      (rbxlua_type(L, (n), FALSE) == rbxlua_TNUMBER)
#define rbxlua_isthread(L,n)       (rbxlua_type(L, (n), FALSE) == rbxlua_TTHREAD)
#define rbxlua_isnone(L,n)         (rbxlua_type(L, (n), TRUE) == rbxlua_TNONE)
#define rbxlua_isnoneornil(L, n)   (rbxlua_type(L, (n), TRUE) <= 0)

#define rbxlua_setglobal(L,s)      rbxlua_setfield(L, rbxlua_GLOBALSINDEX, (s))
#define rbxlua_getglobal(L,s)      rbxlua_getfield(L, rbxlua_GLOBALSINDEX, (s))
#define rbxlua_tostring(L,i)       rbxlua_tolstring(L, (i), NULL)
#define rbxlua_getservice(L,s)		_rbxlua_getservice(L, (s))

////
#define rbxlua_pushcfunction(L,f)	rbxlua_pushcclosure(L, (f), 0)
#define rbxlua_register(L,n,f)		(rbxlua_pushcfunction(L, (f)), rbxlua_setglobal(L, (n)))

#define rbxlua_pushliteral(L, s)	\
	rbxlua_pushlstring(L, "" s, (sizeof(s)/sizeof(char))-1)

/*
** compatibility macros and functions
*/
#define rbxlua_getregistry(L)	rbxlua_pushvalue(L, rbxlua_REGISTRYINDEX)

/*
** {======================================================================
** Debug API
** =======================================================================
*/

/*
** Event codes
*/
#define rbxlua_HOOKCALL	0
#define rbxlua_HOOKRET	1
#define rbxlua_HOOKLINE	2
#define rbxlua_HOOKCOUNT	3
#define rbxlua_HOOKTAILRET 4


/*
** Event masks
*/
#define rbxlua_MASKCALL	(1 << rbxlua_HOOKCALL)
#define rbxlua_MASKRET	(1 << rbxlua_HOOKRET)
#define rbxlua_MASKLINE	(1 << rbxlua_HOOKLINE)
#define rbxlua_MASKCOUNT	(1 << rbxlua_HOOKCOUNT)

////

typedef void* (__cdecl *rbxlua_GetField)(DWORD luaState, int idx, const char *k);
typedef int(__cdecl *rbxlua_PCall)(DWORD luaState, int nargs, int nresults, int errfunc);
typedef void(__cdecl *rbxlua_PushString)(DWORD luaState, const char *s);
typedef void(__cdecl *rbxlua_PushNumber)(DWORD luaState, double Number);
typedef const char *(__cdecl *rbxlua_ToLString)(DWORD luaState, int idx, size_t *len);
typedef void* (__cdecl *rbxlua_PushValue)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_GetTop)(DWORD luaState);
typedef void* (__cdecl *rbxlua_SetTop)(DWORD luaState, int n);
typedef void* (__cdecl *rbxlua_ToUserData)(DWORD luaState, int idx);
typedef void*(__cdecl *rbxlua_SetField)(DWORD luaState, int idx, const char *k);
//typedef void(*rbxlua_SetField)(int luaState, int index, const char *k);
typedef void* (__cdecl *rbxlua_PushCClosure)(DWORD luaState, int fn(), int n);
typedef BOOL(__cdecl *rbxlua_ToBoolean)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_Next)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_Type)(DWORD luaState, int idx);

//typedef int(__cdecl *rbxlua_pushcfunction)(DWORD luaState, int idx); // not correct args!!1
typedef int(__cdecl *rbxlua_Insert)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_Remove)(DWORD luaState, int idx);

typedef int(__cdecl *rbxlua_IsString)(DWORD luaState, int idx); // new

typedef int(__cdecl *rbxlua_Newthread)(DWORD luaState);
typedef int(*rbxlua_error)(DWORD luaState);
typedef void(*rbxlua_createtable)(DWORD luaState, int narr, int nrec);
typedef void(*rbxlua_pushlightuserdata)(DWORD luaState, void *p);
typedef int(__cdecl *rbxlua_Setmetatable)(DWORD luaState, int idx);
typedef int(__cdecl *rbxlua_Newuserdata)(DWORD luaState, size_t size);
typedef void(*rbxlua_pushinteger)(DWORD luaState, ptrdiff_t n);
typedef double(__cdecl *rbxlua_ToNumber)(DWORD luaState, int idx);

typedef int(__cdecl *rbxlua_pushboolf)(DWORD luaState, int idx);


typedef int(__cdecl *rbxlua_Print)(int state, int* msginfo);

rbxlua_pushboolf _rbxlua_pushbool = (rbxlua_pushboolf)rbxaddy(0x545640); // 55 8B EC 8B 55 08 33 C0 39 45 0C

rbxlua_Newthread _rbxlua_newthread = (rbxlua_Newthread)rbxaddy(0x53BBB0); // "Executing lua from signal, execution de" should be 0x5300000 sub by the middle

rbxlua_ToNumber rbxlua_tonumber = (rbxlua_ToNumber)rbxaddy(0x5459C0);/*0x5465E0);/*0x5431A0);/*0x5411B0);/*0x540470);/*0x53D760);/*0x536900);/*0x534200);/*0x5348B0);/*0x534110;/*0x50EE90;/*0x517690;/*0x5180B0;
																	 /* Find "elapsedTime" & "ElapsedTime"
																	 follow the address inbetween them that looks like 'offset sub_NUMBERS'
																	 there should be 2 subs.. it should be the second one :)
																	 */

rbxlua_Print rbxlua_printf = (rbxlua_Print)rbxaddy(0x5067E0); // 2-22-16
															  //updated
rbxlua_PushString _rbxlua_pushstring = (rbxlua_PushString)rbxaddy(0x545A30);//0x546650);//0x543210);//0x541220);//0x5404E0);//0x53D7D0);//0x53E3C0);//0x53C2E0);//0x536C90);//0x536DC0);//0x536E10);//0x534270);//0x534AA0);//0x534920;//0x534180;//0x516F40;//0x517700;//0x518120;//0x518D60;//0x51C280;//0x51BA60;//0x53FE10; // "__tostring"
																			//updated
rbxlua_SetField _rbxlua_setfield = (rbxlua_SetField)rbxaddy(0x546100);/*0x546D20);/*0x5438E0);/*0x5418F0);/*0x540BB0);/*0x53DEA0);/*0x53EA90);/*0x53C9B0);/*0x537360);/*0x537490);/*0x5374E0);/*0x534940);/*0x535170);/*0x533EC0;/*0x534FF0;/*0x534850;/*0x517610;/*0x517DD0;/*0x5187F0;/*0x517D90;//0x519430;/*0x51C950;//
																	  Find "Failed to create Lua state"
																	  //go below to repeated subs and it should look like:
																	  /* // sub_51C950 is the setfield
																	  sub_51C950(v5, -10002, "delay");
																	  sub_51BEF0(v5, sub_508FF0, 0);
																	  sub_51C950(v5, -10002, "Delay");
																	  sub_51BEF0(v5, sub_51A6B0, 0);
																	  sub_51C950(v5, -10002, "ypcall");
																	  sub_51BEF0(v5, sub_51A6B0, 0);
																	  */
																	  /*0x51C950;/*0x51C130;/*0x5404E0;		/*0x53BDA0;
																	  The 'call sub_NUMBERS' right under "wait" AKA aWait; // OLD METHOD


																	  //updated												*/
rbxlua_PushNumber _rbxlua_pushnumber = (rbxlua_PushNumber)rbxaddy(0x5459C0);/*0x5465E0);/*0x5431A0);/*0x5411B0);/*0x540470);/*0x53D760);/*0x53E350);/*0x53C270);/*0x536C20);/*0x536D50);/*0x536DA0);/*0x534200);/*0x534A30);/*0x5348B0;/*0x534110;/*0x516ED0;/*0x517690;/*0x5180B0;/*0x518CF0;/*0x51C210;/*0x51C210;/*0x53FDA0;/*0x53FE50
																			At the very bottom of the string "math" AKA aMath and ontop of "pi" or aPi;
																			//updated												 */
rbxlua_PCall _rbxlua_pcall = (rbxlua_PCall)rbxaddy(0x545590);/*0x5461B0);/*0x542D60);/*0x540D80);/*0x540040);/*0x53D330);/*0x53DF20);/*0x53BE40);/*0x5367F0);/*0x536920);/*0x536970);/*0x533DB0);/*0x534600);/*0x534480;/*0x533CE0;/*0x516AA0;/*0x517260;/*0x517C80;/*0x5188C0;/*0x51BDE0;/*0x51B5C0;/*0x53F970;/*0x5388B0;
															 Find "Breakpoint %d condition runtime error: " AKA aBreakpointDC_0;
															 The first sub_NUMBERS in that function will be pcall;
															 */
															 //updated
rbxlua_ToLString _rbxlua_tolstring = (rbxlua_ToLString)rbxaddy(0x546570);/*0x5471A0);/*0x543D50);/*0x541D60);/*0x541020);/*0x53E310);/*0x53EF00);/*0x53CE20);/*0x5377D0);/*0x537900);/*0x537950);/*0x534DB0);/*0x5355E0);/*0x535460;/*0x534CC0;/*0x517A80;/*0x518240;/*0x518C60;/*0x5198A0;/*0x51CDC0;/*0x51C5A0;/*0x532450;		/*0x53C150;
																		 Find "!handler.empty()" AKA aHandler_empty;
																		 And follow the 'jnz short loc_NUMBERS' right under the emptyhandler;
																		 And find the first sub_NUMBERS and your done!1;
																		 */
																		 //updated// newproxy only supports the arguments ni
rbxlua_SetTop _rbxlua_settop = (rbxlua_SetTop)rbxaddy(0x546390);/*0x546FC0);/*0x543B70);/*0x541B80);/*0x540E40);/*0x53E130);/*0x53ED20);/*0x53CC40);/*0x5375F0);/*0x537720);/*0x537770);/*0x533810);/*0x535280;/*0x533EE0;/*0x533740;/*0x516500;/*0x516CC0;/*0x5176E0;/*0x518320;/*0x51/B840;/*0x51B020;/*0x540770;/*0x53F3D0;				/*0x53BFB0;
																Find "top+1 == rbxlua_gettop(functionThread)" AKA aTop1rbxlua_gettop;
																And the first sub_NUMBERS on the function is the address;
																*/
																//updated
rbxlua_ToBoolean _rbxlua_toboolean = (rbxlua_ToBoolean)rbxaddy(0x5464F0);/*0x547120);/*0x543CD0);/*0x541CE0);/*0x540FA0);/*0x53E290);/*0x53EE80);/*0x53CDA0);/*0x537750);/*0x537880);/*0x5378D0);/*0x534D30);/*0x5353E0);/*0x534C40;/*0x517A00;/*0x5181C0;/*0x518BE0;/*0x519820;/*0x51CD40;/*0x51C520;/*0x5408D0;		/*0x53C0D0;
																		 Find "isdst" AKA aIsdst;
																		 And follow the 'jnz short loc_NUMBERS' in the function;
																		 And it will be the sub_NUMBERS in the function;
																		 [normally right under the aIsdst function];
																		 //updated													*/
rbxlua_Type _rbxlua_type = (rbxlua_Type)rbxaddy(0x5468E0);/*0x547510);/*0x5440C0);/*0x5420D0);/*0x541390);/*0x53E680);/*0x53F270);/*0x53D190);/*0x537B40);/*0x537C70);/*0x537CC0);/*0x535120);/*0x535950);/*0x5357D0;/*0x535030;/*0x517DF0;/*0x5185B0;/*0x518FD0;/*0x519C10;/*0x51D130;/*0x51C910;/*0x540CC0;						/*0x53C440;
														  Find "rbxlua_isthread(functionThread, -1)" AKA arbxlua_isthreadFu;
														  It will be the first sub_NUMBERS in the function;
														  //updated													*/
rbxlua_GetField _rbxlua_getfield = (rbxlua_GetField)rbxaddy(0x544E50);/*0x545A70);/*0x542620);/*0x540640);/*0x53F900);/*0x53CBF0);/*0x53D7E0);/*0x53B700);/*0x5360B0);/*0x5361E0);/*0x536230);/*0x533670);/*0x533EC0);/*0x533D40;/*0x5335A0;/*0x516360;/*0x516B20;/*0x517540;/*0x518180;/*0x518180;/*0x51B6A0;/*0x51D130;/*0x51B6A0;/*0x51B6A0;/*0x51AE80;/*0x53F230;		/*0x53AE70;
																	  Find "__unm" AKA a__unm [it should say offset to the left of a_unm];
																	  Follow the 'offset sub_NUMBERS' right underneath it;
																	  Follow the last loc_NUMBERS in the function;
																	  It should be the first sub_NUMBERS;
																	  //updated													*/
rbxlua_PushValue _rbxlua_pushvalue = (rbxlua_PushValue)rbxaddy(0x545B20);/*0x546740);/*0x543300);/*0x541310);/*0x5405D0);/*0x53D8C0);/*0x53E4B0);/*0x53C3D0);/*0x536D80);/*0x536EB0);/*0x536F00);/*0x534360);/*0x534B90);/*0x534A10;/*0x534270;/*0x517030;/*0x5177F0;/*0x518210;/*0x518E50;/*0x51C370;/*0x51CB70;/*0x572700;/*0x51BB50;/*0x53FF00;		/*0x53B8D0;
																		 Find "%s.%s" AKA aS_S;
																		 In the function look for 'jz short loc_NUMBERS' and follow it;
																		 And it should be the second to last 'call sub_NUMBERS' in the function;
																		 //updated													*/
rbxlua_GetTop _rbxlua_gettop = (rbxlua_GetTop)rbxaddy(0x544FF0);/*0x545C10);/*0x5427C0);/*0x5407E0);/*0x53FAA0);/*0x53CD90);/*0x53D980);/*0x53B8A0);/*0x536250);/*0x536380);/*0x5363D0);/*0x533810);/*0x534060);/*0x533EE0;/*0x533740;/*0x516500;/*0x516CC0;/*0x5176E0;/*0x518320;/*0x51B840;/*0x51B020;/*0x53F3D0;				/*0x53AFB0;
																Find "tostring" AKA aTostring;
																It will be right on top of the "offset aTostring ; "tostring"";
																*/
rbxlua_ToUserData _rbxlua_touserdata = (rbxlua_ToUserData)rbxaddy(0x5468B0);/*0x5474E0);/*0x544090);/*0x5420A0);/*0x541360);/*0x53E650);/*0x53F240);/*0x53D160);/*0x537B10);/*0x537C40);/*0x5357A0);/*0x517DC0;/*0x518580;/*0x518FA0;/*0x519BE0;/*0x51D100;/*0x51C8E0;/*0x540C90;		/*0x53C410;
																			Find "Bad argument materials[%d][%d][%d] to '" AKA aBadArgumentM_0;
																			Should be the 3rd sub_NUMBERS in the function;
																			[and the 1st and 2nd should possibly be the same]
																			*/
rbxlua_Next rbxlua_next = (rbxlua_Next)rbxaddy(0x5366C0);

rbxlua_PushCClosure rbxlua_pushcclosure = (rbxlua_PushCClosure)rbxaddy(0x5456A0);
rbxlua_Insert rbxlua_insert = (rbxlua_Insert)rbxaddy(0x5337F0);
rbxlua_Remove rbxlua_remove = (rbxlua_Remove)rbxaddy(0x534610);

rbxlua_Setmetatable rbxlua_setmetatable = (rbxlua_Setmetatable)rbxaddy(0x5461C0);

rbxlua_Newuserdata rbxlua_newuserdata = (rbxlua_Newuserdata)rbxaddy(0x5453C0);
/*
Search "Width" and it should be the top one, follow it. And sub_533B10 is it!! That is newuserdata!!
.text:00751117 loc_751117:                             ; CODE XREF: .text:00751110j
.text:00751117                 test    eax, eax
.text:00751119                 jnz     short loc_751157
.text:0075111B                 mov     eax, [ebp+8]
.text:0075111E                 mov     esi, [ebp+10h]
.text:00751121                 movss   xmm0, dword ptr [eax+8]
.text:00751126                 movss   dword ptr [ebp-8], xmm0
.text:0075112B                 movss   xmm0, dword ptr [eax+0Ch]
.text:00751130                 push    8
.text:00751132                 push    esi
.text:00751133                 movss   dword ptr [ebp-4], xmm0
.text:00751138                 call    sub_533B10 // IT'S HERE!! IT'S HERE!!!!!!!!!!!!
.text:0075113D                 add     esp, 8
.text:00751140                 test    eax, eax
.text:00751142                 jz      short loc_7510C5
.text:00751144                 movss   xmm0, dword ptr [ebp-8]
.text:00751149                 movss   dword ptr [eax], xmm0
.text:0075114D                 movss   xmm0, dword ptr [ebp-4]
.text:00751152                 jmp     loc_7510C0
.text:00751157 ; ---------------------------------------------------------------------------
.text:00751157
.text:00751157 loc_751157:                             ; CODE XREF: .text:00751119j
.text:00751157                 mov     ecx, offset aWidth ; "Width"
.text:0075115C                 mov     eax, esi
.text:0075115E                 mov     edi, edi
*/
/*
static int l_cppfunction(lua_State *L) {
double arg = luaL_checknumber(L, 1);
lua_pushnumber(L, arg * 0.5);
return 1;
}
*/
int stackSize() { return rbxlua_gettop(luaState); }
void checkStack() { assert(rbxlua_gettop(luaState) <= 20); }
bool hasIndex(int index) {
	return (stackSize() >= (index < 0 ? -index : index) && index != 0);
}
void clearStack() {
	int size = stackSize();
	if (size > 0) {
		rbxlua_settop(luaState, 0); Sleep(50);//-(size)-1); Sleep(50);
	}
}

void rbxpushinst(DWORD s, int inst) { // not tested.. address is from 4-12-2016
	((void(__cdecl*)(int, int, int))0x52B8D0)(s, *(DWORD*)inst, 0);
}

void rbxlua_gettable(DWORD a1, int a2) {
	int v2 = ((int(__cdecl*)(int, int))0x533560)(a1, a2); // same as settable
	((int(__cdecl*)(int, int, int, int))0x786690)(a1, v2, *(DWORD *)(a1 + 16) - 16, *(DWORD *)(a1 + 16) - 16); //0x784320 // Find "loop in gettable"; and the addr is the function
}

void rbxlua_settable(DWORD a1, int a2) {
	int v2 = a1;
	int v3 = ((int(__cdecl*)(int, int))0x535A00)(a1, a2); //0x532DC0// inside rbxlua_getfield it is the v3 sub that looks like this: v3 = sub_533560(a1, a2);
	((int(__cdecl*)(int, int, int, int))0x798BC0)(v2, v3, *(DWORD *)(v2 + 16) - 32, *(DWORD *)(v2 + 16) - 16); //0x784490// Find "Attempt to modify a readonly table" and it should be the last result sub_NUMBERS and might start with a 7
	*(DWORD *)(v2 + 16) -= 32;
}

void _rbxlua_pushnil(DWORD luaState) { // rbxlua_pushnil
	__try {
		*(DWORD*)(*(DWORD *)(luaState + 16) + 8) = 0;
		*(DWORD*)(luaState + 16) += 16;
	}
	__except (EXCEPTION_EXECUTE_HANDLER) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 1", "", 0); Sleep(1);
	}
}

void rbxsetfield(DWORD s, int k, const char* n) {
	rbxlua_pushstring(s, n);
	rbxlua_pushvalue(s, -2);
	rbxlua_settable(s, k);
	//rbxlua_pop(s, -1);
}

void rbxluastackdump_g(DWORD luaState) {//lua_State* l) {
	int i;
	int top = rbxlua_gettop(luaState);
	std::string strtop("total in stack %d\n" + std::to_string(top));
	ConsoleOutput(strtop);//top);
	for (i = 1; i <= top; i++) {  /* repeat for each level */
		int t = rbxlua_type(luaState, i, FALSE);
		switch (t) {
		case LUA_TSTRING:  /* strings */
			ConsoleOutput("string: '%s'\n", rbxlua_tostring(luaState, i));
			break;
		case LUA_TBOOLEAN:  /* booleans */
			ConsoleOutput("boolean %s\n", rbxlua_toboolean(luaState, i) ? "true" : "false");
			break;
		case LUA_TNUMBER:  /* numbers */
			ConsoleOutput("number: %g\n", rbxlua_tonumber(luaState, i));
			break;
		default:  /* other values */
			ConsoleOutput("code: '%s'\n", rbxlua_tostring(luaState, i));
			//printf("%s\n", rbxlua_type(luaState, t, FALSE));
			//printf(">\n");
			break;
		}
		ConsoleOutput("  ");  /* put a separator */
	}
	ConsoleOutput("\n");  /* end the listing */
}

void rbxlua_pushnil(DWORD luaState) {
	try {
		_rbxlua_pushnil(luaState);
	}
	catch (std::exception& e) {
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 2", "", 0);
	}
}

int rbxlua_touserdata(DWORD luaState, int idx) {
	int data = 0;
	try {
		data = *(int*)_rbxlua_touserdata(luaState, -1);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 3", "", 0);
	}
	return data;
}

int _rbxlua_getservice(DWORD luaState, const char* ServiceName) { // custom function // -5 or -6
	if (ServiceName != "") {
		rbxlua_getglobal(luaState, ServiceName);
		if (rbxlua_isnil(luaState, -1)) { // no '!' at the start since we are checking to make sure it's nil
			rbxlua_getglobal(luaState, "game");
			if (!rbxlua_isnil(luaState, -1)) {
				rbxlua_getfield(luaState, -1, "GetService");
				if (rbxlua_isfunction(luaState, -1)) {
					rbxlua_pushvalue(luaState, -2);
					rbxlua_pushstring(luaState, ServiceName);
					rbxlua_pcall(luaState, 2, 1, 0);
					if (!rbxlua_isnil(luaState, -1)) {
						rbxlua_setglobal(luaState, ServiceName);
						rbxlua_getglobal(luaState, ServiceName);
						return 1;
					}
					else {
						return 0;
						clearStack();
					}
				}
				else {
					clearStack();
					return 0;
				}
			}
		}
		else {
			return 1;
		}
	}
	return 0;
}

int rbxlua_getobject(DWORD luaState, int idx) {
	return (int)rbxlua_touserdata(luaState, idx);
}

// pushbool: use pushnumber 1 to push a true boolean, use pushnil to push false

/*void rbxlua_pushbool(DWORD luaState, int a2) {
	__try {
		int v2 = *(DWORD*)(luaState + 16);
		*(DWORD*)(v2 + 8) = 3;
		*(DWORD*)v2 = a2 != 0;
		*(DWORD*)(luaState + 16) += 16;
	}
	__except (EXCEPTION_EXECUTE_HANDLER) {
		Sleep(1);
	}
}*/

void rbxlua_pushbool(DWORD luaState, BOOL val) { // custom function
	try {
		_rbxlua_pushbool(luaState, val);
	}
	catch (std::exception) {}
	catch (...) {}
	/*if (val == TRUE) {
		rbxlua_pushnumber(luaState, 1);
	}
	else if (val == FALSE) {
		rbxlua_pushnil(luaState);
	}*/
}

int rbxlua_pcall(DWORD luaState, int nargs, int nresults, int errfunc) {
	int start = 0;
	try {
		start = _rbxlua_pcall(luaState, nargs, nresults, errfunc);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 4", "", 0);
	}
	return start;
}
/*
int rbxlua_isnil(DWORD luaState, int idx) {
try {
if (rbxlua_type(luaState, (idx)) == Rrbxlua_TNIL) {
return 1;
}
else {
return 0;
}
//ret = new int(_rbxlua_type(luaState, idx));
}
catch (std::exception& e) {
return 1;
MessageBoxA(0, e.what(), "", 0);
}
catch (...) {
return 1;
MessageBoxA(0, "A unexpected error has occured!", "", 0);
}
return 1;
}
*/
/*
int rbxlua_newuserdata(DWORD luaState, size_t size) {
try {
_rbxlua_newuserdata(luaState, size);
}
catch (std::exception& e) {
MessageBoxA(0, e.what(), "", 0);
}
catch (...) {
MessageBoxA(0, "A unexpected error has occured! ERROR#: 6", "", 0);
}
}
*/

int rbxlua_newthread(DWORD luaState) {
	try {
		return _rbxlua_newthread(luaState);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
		return 0;
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: newthread", "", 0);
		return 0;
	}
	return 0;
}

int rbxlua_type(DWORD luaState, int idx, BOOL IsNil) { // custom function
	int ret;
	//luaL_checktype(L, 2, LUA_TTABLE);
	try {
		ret = _rbxlua_type(luaState, idx);
	}
	catch (std::exception& e) {
		//clearStack();
		if (IsNil == TRUE) { // luaL_checktype(luaState, idx, _rbxlua_TNIL);
			ret = luaState;
		}
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		if (IsNil == TRUE) {
			ret = luaState;
		}
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 5", "", 0);
	}
	return ret;
}

std::string rbxlua_getvalue(DWORD luaState, int idx, const char* k) { // custom function
	std::string val;
	rbxlua_getfield(luaState, idx, k);
	val = rbxlua_tostring(luaState, idx);
	return val;
}

void rbxlua_pushstring(DWORD luaState, const char *s) {
	try {
		//rbxlua_pushlstring(luaState, s, strlen(s));
		_rbxlua_pushstring(luaState, s);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 6", "", 0);
	}
}

void rbxlua_pushnumber(DWORD luaState, double Number) {
	try {
		_rbxlua_pushnumber(luaState, double(Number));
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 7", "", 0);
	}
}
const char* rbxlua_tolstring(DWORD luaState, int idx, size_t *len) {
	//const char** ret;
	const char* ret;
	try {
		ret = _rbxlua_tolstring(luaState, idx, len);
		//ret = new const char*(_rbxlua_tolstring(luaState, idx, len));
	}
	catch (std::exception& e) {
		//clearStack();
		//free(&ret);
		MessageBoxA(0, e.what(), "", 0);
		return (const char*)"Failed to grab error!";
	}
	catch (...) {
		//clearStack();
		//free(&ret);
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 8", "", 0);
	}
	return ret;//*ret;
}

void rbxlua_pushlstring(DWORD luaState, const char* a2, int a3) {
	__try {
		if (*(DWORD *)(*(DWORD *)(luaState + 8) + luaState + 96) >= *(DWORD *)(*(DWORD *)(luaState + 8) + luaState + 84))
			((void(__cdecl*)(DWORD))0x7945B0)(luaState);
		int v3 = *(DWORD *)(luaState + 16);
		*(DWORD *)v3 = ((int(__cdecl*)(DWORD, const char*, int))0x538490)(luaState, a2, a3);
		*(DWORD *)(v3 + 8) = 4;
		*(DWORD *)(luaState + 16) += 16;
	}
	__except (EXCEPTION_EXECUTE_HANDLER) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: pushlstring", "", 0); Sleep(1);
	}
}

void rbxlua_pushvalue(DWORD luaState, int idx) {
	try {
		_rbxlua_pushvalue(luaState, idx);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 9", "", 0);
	}
}

void rbxlua_settop(DWORD luaState, int a2) {
	int i = 0;
	if (a2 < 0) {
		__try {
			*(DWORD *)(luaState + 16) += 16 * a2 + 16;
		}
		__except (EXCEPTION_EXECUTE_HANDLER) {
			Sleep(1);
		}
		rbxlua_pcall(luaState, 0, 0, 0);
	}
	else {
		__try {
			for (i = 16 * a2; *(DWORD *)(luaState + 16) < (unsigned int)(i + *(DWORD *)(luaState + 28)); *(DWORD *)(luaState + 16) += 16)
				*(DWORD *)(*(DWORD *)(luaState + 16) + 8) = 0;
			*(DWORD *)(luaState + 16) = i + *(DWORD *)(luaState + 28);
		}
		__except (EXCEPTION_EXECUTE_HANDLER) {
			Sleep(1);
		}
		rbxlua_pcall(luaState, 0, 0, 0);
	}
}

/*void rbxlua_settop(DWORD luaState, int n) {
try {
_rbxlua_settop(luaState, n);
}
catch (std::exception& e) {
clearStack();
MessageBoxA(0, e.what(), "ERROR", 0);
}
catch (...) {
clearStack();
//MessageBoxA(0, "A unexpected error has occured! ERROR#: 10", "", 0); Sleep(25);
}
}*/

/*void rbxlua_setfield(DWORD luaState, int k, const char* n) {
rbxlua_pushstring(luaState, n);
rbxlua_pushvalue(luaState, -2);
rbxlua_settable(luaState, k);
rbxlua_pop(luaState, -1);
}*/

void rbxlua_setfield(DWORD luaState, int idx, const char *k) {
	try {
		_rbxlua_setfield(luaState, idx, k);
		//((void*(__cdecl*)(int, int, const char*))0x535170)(luaState, idx, k);
	}
	catch (std::exception& e) {
		//clearStack();
		MessageBoxA(0, e.what(), "ERROR", 0);
	}
	catch (...) {
		//clearStack();
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 11", "", 0); Sleep(25);
	}
}

BOOL rbxlua_toboolean(DWORD luaState, int idx) {
	try {
		return _rbxlua_toboolean(luaState, idx);
	}
	catch (std::exception& e) {
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 12", "", 0);
	}
	return NULL;
}

void rbxlua_emptystack(DWORD luaState) {
	try {
		rbxlua_settop(luaState, 0);
	}
	catch (std::exception& e) {
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 13", "", 0);
	}
}

void rbxlua_pop(DWORD luaState, int n) {
	try {
		_rbxlua_settop(luaState, -(n)-1);
	}
	catch (std::exception& e) {
		MessageBoxA(0, e.what(), "", 0);
	}
	catch (...) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: 14", "", 0);
	}
}

int rbxlua_getfield(DWORD luaState, int idx, const char *k) {
	try {
		_rbxlua_getfield(luaState, idx, k);
	}
	catch (std::exception) {//& e) {
							//clearStack();
							//MessageBoxA(0, e.what(), "getfield", 0);
							//_rbxlua_getfield(luaState, rbxlua_GLOBALSINDEX, "game");
		return 1;
	}
	catch (...) {
		//clearStack();
		//MessageBoxA(0, "A unexpected error has occured! ERROR#: 15", "", 0);
		//luaL_error(L, "We've run into an error! ERROR CODE: 0x15");
		return 1;
	}
	return 0;
}

/*int rbxlua_gettop(DWORD luaState) {
try {
return (*(DWORD*)(luaState + 16) - *(DWORD*)(luaState + 28)) >> 4;//_rbxlua_gettop(luaState);
}
catch (std::exception& e) {
MessageBoxA(0, e.what(), "", 0);
}
catch (std::invalid_argument e) {
MessageBoxA(0, e.what(), "Invalid argument!", 0);
}
catch (...) {
MessageBoxA(0, "A unexpected error has occured! ERROR#: 16", "", 0);
}
return 0;
}*/

int rbxlua_gettop(DWORD luaState) {
	int top = 0;
	__try {
		top = (*(DWORD*)(luaState + 16) - *(DWORD*)(luaState + 28)) >> 4;
	}
	__except (EXCEPTION_EXECUTE_HANDLER) {
		MessageBoxA(0, "A unexpected error has occured! ERROR#: rbxlua_gettop", "", 0); Sleep(1);
	}
	return top;
}

std::string HttpGet(std::string URL) {
	rbxlua_getglobal(luaState, "game");
	if (!rbxlua_isnil(luaState, -1)) {
		rbxlua_getfield(luaState, -1, "HttpGet");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushstring(luaState, URL.c_str());
		rbxlua_pushbool(luaState, 1);
		rbxlua_pcall(luaState, 3, 1, 0); Sleep(50);

		std::string returnval = rbxlua_tostring(luaState, -1);
		return returnval;
	}
	return *(std::string*)"";
}

void LoadGame(std::string URL) {
	rbxlua_getglobal(luaState, "game");
	if (!rbxlua_isnil(luaState, -1)) {
		std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=") + std::string(URL);
		rbxlua_getfield(luaState, -1, "Load");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushstring(luaState, FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}
}

void LoadInAsset(std::string URL) {
	rbxlua_getservice(luaState, "InsertService");
	if (!rbxlua_isnil(luaState, -1)) {
		std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=");
		rbxlua_getfield(luaState, -1, "SetAssetUrl");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushstring(luaState, FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}

	rbxlua_getservice(luaState, "InsertService");
	if (!rbxlua_isnil(luaState, -1)) {
		//std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=") + std::string(URL);
		rbxlua_getfield(luaState, -1, "SetTrustLevel");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushnumber(luaState, 255);
		//rbxlua_pushstring(luaState, URL.c_str());//FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}

	rbxlua_getservice(luaState, "InsertService");
	if (!rbxlua_isnil(luaState, -1)) {
		//std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=") + std::string(URL);
		rbxlua_getfield(luaState, -1, "ApproveAssetId");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushnumber(luaState, std::stoi(URL));
		//rbxlua_pushstring(luaState, URL.c_str());//FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}

	rbxlua_getservice(luaState, "InsertService");
	if (!rbxlua_isnil(luaState, -1)) {
		//std::string FixedURL = std::string("http://assetgame.roblox.com/Asset/?id=") + std::string(URL);
		rbxlua_getfield(luaState, -1, "LoadAsset");
		rbxlua_pushvalue(luaState, -2);
		rbxlua_pushnumber(luaState, std::stoi(URL));
		//rbxlua_pushstring(luaState, URL.c_str());//FixedURL.c_str());
		rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
	}
}

std::map<int, Inst*> InstanceMap = {};
std::map<int, LuaInst*> LuaInstanceMap = {};
int WrapToLua(lua_State* L, int InstRef);
template <typename T> static inline T *CheckInstanceUnsafe(lua_State *L, int idx, bool selfCheck = true) {
	static_assert(std::is_base_of<Inst, T>::value, "T must inherit from Instance");
	if (lua_isnil(L, idx)) {
		const char *msg = lua_pushfstring(L, "Instance expected, got nil");
		lua_pop(L, 1);
		luaL_argerror(L, idx, msg);
		return NULL;
	}
	void *udata = lua_touserdata(L, idx);
	if (udata == NULL) {
		if (selfCheck) {
			const char *msg = lua_pushfstring(L, "Instance expected, got %s", lua_typename(L, lua_type(L, idx)));
			lua_pop(L, 1);
			luaL_argerror(L, idx, msg);
		}
		return NULL;
	}
	Inst *inst = *((Inst**)udata);
	T *requested_instance = dynamic_cast<T*>(inst);
	if (requested_instance == NULL) {
		if (selfCheck) {
			const char *msg = lua_pushfstring(L, "Instance expected, got userdata");
			lua_pop(L, 1);
			luaL_argerror(L, idx, msg);
		}
	}
	return requested_instance;
}

template <typename T> static inline T *CheckInstance(lua_State *L, int idx, bool selfCheck = true) {
	__try {
		return CheckInstanceUnsafe<T>(L, idx, selfCheck);
	}
	__except (EXCEPTION_EXECUTE_HANDLER) {
		Sleep(0);
	}
	luaL_error(L, "A unexpected error has occured! ERROR CODE: 0x14");
	return nullptr;
}

void LuaThreadHandler(ThreadParams* tParams) {
	if (tParams->Time > 0)
		std::this_thread::sleep_for(std::chrono::milliseconds(tParams->Time * 1000));
	lua_settop(tParams->lThread, 0);
	lua_rawgeti(tParams->lThread, LUA_REGISTRYINDEX, tParams->fRef);
	int Results = lua_pcall(tParams->lThread, 0, 0, 0);
	if (Results != 0) {
		//MessageBox(NULL, lua_tostring(tParams->lThread, -1), TEXT("Lua Error"), NULL);
		ConsoleOutput(std::string("Lua Error: ") + lua_tostring(tParams->lThread, -1), RGB(255, 0, 0));
		lua_settop(tParams->lThread, 0);
	}
}

template <typename T>
T* rbxlua_grabobject(DWORD luaState, int index) {
	T* obj = NULL;
	if (rbxlua_type<T>(luaState, index)) {
		obj = *(T**)rbxlua_touserdata(luaState, index);
	}
	return obj;
}

int LuaCurrentEpoch(lua_State *L) {
	std::chrono::milliseconds a = std::chrono::duration_cast<std::chrono::milliseconds>(std::chrono::system_clock::now().time_since_epoch());
	lua_pushnumber(L, a.count() / 1000);
	return 1;
}

int luaToString(lua_State* L) {
	Inst* ind = CheckInstance<Inst>(L, 1);
	if (ind) {
		rbxlua_pushstring((DWORD)L, GetName(ind->InstanceRef).c_str());
		return 1;
	}
	return 0;
}

int luaWait(lua_State* L) {
	double WaitTime = 0;
	if (lua_gettop(L) > 0) {
		WaitTime = luaL_checknumber(L, 1);
	}
	std::this_thread::sleep_for(std::chrono::milliseconds((int)WaitTime * 1000));
	return 0;
}

int luaSpawn(lua_State* L) {
	if (lua_type(L, 1) != LUA_TFUNCTION) {
		return luaL_error(L, "Function expected, got %s", lua_typename(L, lua_type(L, 1)));
	}
	int fRef = lua_ref(L, LUA_REGISTRYINDEX);
	ThreadParams tParams{
		lua_newthread(L),
		fRef,
		0
	};
	std::thread LuaThread(&LuaThreadHandler, &tParams);
	LuaThread.detach();
	lua_settop(L, 0);
}

int luaDelay(lua_State* L) {
	int Time = luaL_checkinteger(L, 1);
	if (lua_type(L, 2) != LUA_TFUNCTION) {
		return luaL_error(L, "Function expected, got %s", lua_typename(L, lua_type(L, 1)));
	}
	int fRef = lua_ref(L, LUA_REGISTRYINDEX);
	ThreadParams tParams{
		lua_newthread(L),
		fRef,
		Time
	};
	std::thread LuaThread(&LuaThreadHandler, &tParams);
	LuaThread.detach();
	lua_settop(L, 0);
}


static int LuaWarn(lua_State* L) {
	int n = lua_gettop(L);  // number of arguments
	int i;
	std::string out;
	lua_getglobal(L, "tostring");
	for (i = 1; i <= n; i++) {
		const char *s;
		lua_pushvalue(L, -1);  // function to be called
		lua_pushvalue(L, i);   // value to print
							   //rbxlua_call(L, 1, 1);
		if (!lua_isnil(L, i)) {
			if (lua_isstring(L, -1)) {
				s = lua_tostring(L, -1);  // get result
				if (s == NULL) {
					s = "nil";
					//return luaL_error(L, LUA_QL("tostring") " must return a string to "
					//	LUA_QL("warn"));
				}
			}
			/*else {
			void *udata = lua_touserdata(L, -1);
			if (udata != NULL) {
			s = GetClass((int)udata);
			}
			}*/
		}
		else {
			s = "nil";
		}
		if (i > 1) out += "\t";
		out += s;
		lua_pop(L, 1);  // pop result
	}
	rbxlua_getglobal(luaState, "warn");
	rbxlua_pushstring(luaState, out.c_str());
	rbxlua_pcall(luaState, 1, 0, 0);
	return 0;
}

static int LuaPrint(lua_State* L) {
	int n = lua_gettop(L);  // number of arguments
	int i;
	std::string out;
	lua_getglobal(L, "tostring");
	for (i = 1; i <= n; i++) {
		const char *s;
		lua_pushvalue(L, -1);  // function to be called
		lua_pushvalue(L, i);   // value to print
							   //rbxlua_call(L, 1, 1);
		if (!lua_isnil(L, i)) {
			if (lua_isstring(L, -1)) {
				s = lua_tostring(L, -1);  // get result
				if (s == NULL) {
					s = "nil";
					//return luaL_error(L, LUA_QL("tostring") " must return a string to "
					//	LUA_QL("print"));
				}
			}
			/*else {
				void *udata = lua_touserdata(L, -1);
				if (udata != NULL) {
					s = GetClass((int)udata);
				}
			}*/
		}
		else {
			s = "nil";
		}
		if (i > 1) out += "\t";
		out += s;
		lua_pop(L, 1);  // pop result
	}
	rbxlua_getglobal(luaState, "print");
	rbxlua_pushstring(luaState, out.c_str());
	rbxlua_pcall(luaState, 1, 0, 0);
	return 0;
}

static int LuaError(lua_State* L) {
	int n = lua_gettop(L);  // number of arguments
	int i;
	std::string out;
	lua_getglobal(L, "tostring");
	for (i = 1; i <= n; i++) {
		const char *s;
		lua_pushvalue(L, -1);  //
		lua_pushvalue(L, i);
		lua_call(L, 1, 1);
		s = lua_tostring(L, -1);
		if (s == NULL)
			return luaL_error(L, LUA_QL("tostring") " must return a string to "
				LUA_QL("print"));
		if (i > 1) out += "\t";
		out += s;
		lua_pop(L, 1);
	}
	rbxlua_getglobal(luaState, "error");
	rbxlua_pushstring(luaState, out.c_str());
	//rbxlua_pushnumber(luaState, 1);
	rbxlua_pcall(luaState, 1, 0, 0);
	return 0;
}

static int LuaConsolePrint(lua_State* L) {
	int n = lua_gettop(L);  // number of arguments
	int i;
	std::string out;
	lua_getglobal(L, "tostring");
	for (i = 1; i <= n; i++) {
		const char *s;
		lua_pushvalue(L, -1);  // function to be called
		lua_pushvalue(L, i);   // value to print
							   //rbxlua_call(L, 1, 1);
		if (!lua_isnil(L, i)) {
			if (lua_isstring(L, -1)) {
				s = lua_tostring(L, -1);  // get result
				if (s == NULL) {
					s = "nil";
					//return luaL_error(L, LUA_QL("tostring") " must return a string to "
					//	LUA_QL("print"));
				}
			}
			/*else {
			void *udata = lua_touserdata(L, -1);
			if (udata != NULL) {
			s = GetClass((int)udata);
			}
			}*/
		}
		else {
			s = "nil";
		}
		if (i > 1) out += "\t";
		out += s;
		lua_pop(L, 1);  // pop result
	}
	out = out + "\r\n";
	ConsoleOutput(out);
	return 0;
}

std::map < std::string, std::map<std::string, lua_CFunction> > ClassFuncs = {
	{ "RemoteEvent",{
		{ "FireServer", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		rbxlua_getfield(luaState, -1, "FireServer");
		rbxlua_pushvalue(luaState, -2);
		int numberofargs = lua_gettop(L) - 1;
		if (numberofargs >= 0) {
			if (lua_gettop(L) == 2) { // 1 args

			}
			rbxlua_pcall(luaState, numberofargs, 0, 0);
		}
		else {
			clearStack();
		}
	}
	return 0;
} }
	} },
	/*{ "Debris",{
		{ "AddItem", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		if (!lua_isnumber(L, 3)) luaL_argerror(L, 3, "number expected");
		rbxWrapToLua(luaState, inst->InstanceRef);
		rbxlua_getfield(luaState, -1, "AddItem");
		rbxlua_pushvalue(luaState, -2);

		rbxWrapToLua(luaState, inst->InstanceRef);
		rbxlua_pushvalue(luaState, -2);

		rbxlua_pcall(luaState, 2, 0, 0);
	}
	return 0;
} }
	} },*/
	{ "StarterGui",{
		{ "SetCoreGuiEnabled", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		const char* TypeGui = luaL_checkstring(L, 2);
		if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
		bool boolval = lua_toboolean(L, 3);
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "SetCoreGuiEnabled");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pushstring(luaState, TypeGui);
			rbxlua_pushbool(luaState, boolval);
			rbxlua_pcall(luaState, 3, 0, 0);
		}
	}
	return 0;
} }
	} },
	{ "Sound",{
		{ "Play", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Play");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
	}
	return 0;
} },
{ "play", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Play");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
	}
	return 0;
} },
{ "Stop", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Stop");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
	}
	return 0;
} },
{ "stop", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Stop");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
	}
	return 0;
} },
{ "Resume", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Resume");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
	}
	return 0;
} },
{ "Pause", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Pause");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
	}
	return 0;
} }
	} },
	{ "Part",{
		{ "BreakJoints", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		BreakJoints(inst->InstanceRef);
	}
	return 0;
} },
{ "breakJoints", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		BreakJoints(inst->InstanceRef);
	}
	return 0;
} },
	} },
	{ "Model",{
		{ "BreakJoints", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		BreakJoints(inst->InstanceRef);
	}
	return 0;
} },
{ "breakJoints", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		BreakJoints(inst->InstanceRef);
	}
	return 0;
} },
	} },
	{ "Workspace",{
		{ "BreakJoints", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		BreakJoints(inst->InstanceRef);
	}
	return 0;
} },
{ "breakJoints", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		BreakJoints(inst->InstanceRef);
	}
	return 0;
} },
	} },
	{ "Humanoid",{
		{ "UnequipTools", [](lua_State* L)->int {
		Inst* inst = CheckInstance<Inst>(L, 1);
		try {
			UnequipTools(inst->InstanceRef);
		}
		catch (std::exception&) {
			Sleep(1);
		}
		return 0;
} },
	} },
	{ "Terrain",{
		{ "Clear", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		//ClearTerrain(inst->InstanceRef);
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Clear");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
	}
	return 0;
} },
{ "clear", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		//ClearTerrain(inst->InstanceRef);
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Clear");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
	}
	return 0;
} },
	} },
	{ "Players",{
		{ "GetPlayers", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		std::vector<DWORD> Children = GetChildren(Players);
		lua_newtable(L);
		for (int c = 0; c < Children.size(); c++) {
			if (strcmp(GetClass(Children[c]), "Player") == 0) {
				lua_pushinteger(L, c + 1);
				WrapToLua(L, Children[c]);
				lua_settable(L, -3);
			}
		}
		lua_pushvalue(L, -1);
		return 1;
	}
} },
{ "getPlayers", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		std::vector<DWORD> Children = GetChildren(Players);
		lua_newtable(L);
		for (int c = 0; c < Children.size(); c++) {
			if (strcmp(GetClass(Children[c]), "Player") == 0) {
				lua_pushinteger(L, c + 1);
				WrapToLua(L, Children[c]);
				lua_settable(L, -3);
			}
		}
		lua_pushvalue(L, -1);
		return 1;
	}
} },
{ "players", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		std::vector<DWORD> Children = GetChildren(Players);
		lua_newtable(L);
		for (int c = 0; c < Children.size(); c++) {
			if (strcmp(GetClass(Children[c]), "Player") == 0) {
				lua_pushinteger(L, c + 1);
				WrapToLua(L, Children[c]);
				lua_settable(L, -3);
			}
		}
		lua_pushvalue(L, -1);
		return 1;
	}
} }
	} },
	{ "DataModel",{
		{ "Load", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		const char* URL = luaL_checkstring(L, 2);
		rbxlua_getglobal(luaState, "game");
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Load");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pushstring(luaState, URL);
			rbxlua_pcall(luaState, 2, 0, 0); Sleep(50);
			return 1;
		}
		luaL_error(L, "Unknown error occured!", URL);
		return 0;
	}
	return 0;
} },
{ "HttpGet", [](lua_State* L)->int {
	const char* URL = luaL_checkstring(L, 2);
	if (URL) {
		rbxlua_getglobal(luaState, "game");
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "HttpGet");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pushstring(luaState, URL);
			if (lua_isboolean(L, 3)) {
				bool val = rbxlua_toboolean(luaState, 2);
				rbxlua_pushbool(luaState, val ? 1 : 0);
			}
			else {
				rbxlua_pushbool(luaState, 1);
			}
			rbxlua_pcall(luaState, 3, 1, 0); Sleep(50);
			std::string returnval = rbxlua_tostring(luaState, -1);
			lua_pushstring(L, returnval.c_str());
			return 1;
		}
		luaL_error(L, "Unknown error occured!", URL);
		return 0;
	}
	return 0;
} },{ "GetService", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		const char* Service = luaL_checkstring(L, 2);
		std::vector<DWORD> Services = GetChildren(inst->InstanceRef);
		for (int c = 0; c < Services.size(); c++) {
			if (strcmp(GetName(Services[c]).c_str(), Service) == 0) {
				WrapToLua(L, Services[c]);
				lua_pushvalue(L, -1);
				return 1;
			}
		}
		luaL_error(L, "'%s' is not a valid service name.", Service);
		return 0;
	}
	return 0;
} },{ "service", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		const char* Cool = luaL_checkstring(L, 2);
		std::vector<DWORD> Services = GetChildren(inst->InstanceRef);
		for (int c = 0; c < Services.size(); c++) {
			if (strcmp(GetName(Services[c]).c_str(), Cool) == 0) {
				WrapToLua(L, Services[c]);
				lua_pushvalue(L, -1);
				return 1;
			}
		}
		luaL_error(L, "'%s' is not a valid service name.", Cool);
		return 0;
	}
	return 0;
} },
	} },
	/*{ "LocalScript",{
		{ "BreakScript", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		((void(__thiscall*)(int, int))0x503DF0)(ScriptContext, inst->InstanceRef);
	}
	return 0;
} },
	} },*/
	{ "1337IsBack",{
{ "remove", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "remove");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
		//iDestroy(inst->InstanceRef, 1);
	}
	return 0;
} },
{ "Remove", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "remove");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
		//iDestroy(inst->InstanceRef, 1);
	}
	return 0;
} },
{ "destroy", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Destroy");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
		//iDestroy(inst->InstanceRef, 1);
	}
	return 0;
} },
{ "Destroy", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst != nullptr) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Destroy");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
		//iDestroy(inst->InstanceRef, 1);
	}
	return 0;
} },
{ "GetChildren", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		std::vector<DWORD> Children = GetChildren(inst->InstanceRef);
		lua_newtable(L);
		for (int c = 0; c < Children.size(); c++) {
			lua_pushinteger(L, c + 1);
			WrapToLua(L, Children[c]);
			lua_settable(L, -3);
		}
		lua_pushvalue(L, -1);
		return 1;
	}
	return 0;
} },
{ "getChildren", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		std::vector<DWORD> Children = GetChildren(inst->InstanceRef);
		lua_newtable(L);
		for (int c = 0; c < Children.size(); c++) {
			lua_pushinteger(L, c + 1);
			WrapToLua(L, Children[c]);
			lua_settable(L, -3);
		}
		lua_pushvalue(L, -1);
		return 1;
	}
	return 0;
} },
{ "children", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		std::vector<DWORD> Children = GetChildren(inst->InstanceRef);
		lua_newtable(L);
		for (int c = 0; c < Children.size(); c++) {
			lua_pushinteger(L, c + 1);
			WrapToLua(L, Children[c]);
			lua_settable(L, -3);
		}
		lua_pushvalue(L, -1);
		return 1;
	}
	return 0;
} },
{ "Clone", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "Clone");
			if (rbxlua_isfunction(luaState, -1)) {
				rbxlua_pushvalue(luaState, -2);
				rbxlua_pcall(luaState, 1, 1, 0); Sleep(5);
				if (!rbxlua_isnil(luaState, -1)) {
					int newIns = rbxlua_touserdata(luaState, -1);
					if (newIns > 0) {
						WrapToLua(L, newIns);
						lua_pushvalue(L, -1); Sleep(5);
						return 1;
					}
				}
			}
		}
	}
	return 0;
} },
{ "clone", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "clone");
			if (rbxlua_isfunction(luaState, -1)) {
				rbxlua_pushvalue(luaState, -2);
				rbxlua_pcall(luaState, 1, 1, 0); Sleep(5);
				if (!rbxlua_isnil(luaState, -1)) {
					int newIns = rbxlua_touserdata(luaState, -1);
					if (newIns > 0) {
						WrapToLua(L, newIns);
						lua_pushvalue(L, -1); Sleep(5);
						return 1;
					}
				}
			}
		}
	}
	return 0;
} },
{ "IsA", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		const char* MoreCool = luaL_checkstring(L, 2);
		const char* Ins = GetClass(inst->InstanceRef);
		if (Ins != "0") {
			if (strcmp(MoreCool, Ins) == 0) {
				lua_pushboolean(L, 1);
			}
			else {
				lua_pushboolean(L, 0);
			}
			return 1;
		}
		return 0;
	}
	return 0;
} },
{ "isA", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		const char* MoreCool = luaL_checkstring(L, 2);
		const char* Ins = GetClass(inst->InstanceRef);
		if (Ins != "0") {
			if (strcmp(MoreCool, Ins) == 0) {
				lua_pushboolean(L, 1);
			}
			else {
				lua_pushboolean(L, 0);
			}
			return 1;
		}
		return 0;
	}
	return 0;
} },
{ "FindService", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		const char* MoreCool = luaL_checkstring(L, 2);
		int Ins = FindFirstChild(inst->InstanceRef, std::string(MoreCool));
		if (Ins) {
			WrapToLua(L, Ins);
			lua_pushvalue(L, -1);
			return 1;
		}
		return 0;
	}
	return 0;
} },
{ "FindFirstChild", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		const char* MoreCool = luaL_checkstring(L, 2);
		int Ins = FindFirstChild(inst->InstanceRef, std::string(MoreCool));
		if (Ins) {
			WrapToLua(L, Ins);
			lua_pushvalue(L, -1);
			return 1;
		}
		return 0;
	}
	return 0;
} },
{ "findFirstChild", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		const char* MoreCool = luaL_checkstring(L, 2);
		int Ins = FindFirstChild(inst->InstanceRef, std::string(MoreCool));
		if (Ins) {
			WrapToLua(L, Ins);
			lua_pushvalue(L, -1);
			return 1;
		}
		return 0;
	}
	return 0;
} },
{ "GetFullName", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		std::string strIns = GetFullName(inst->InstanceRef);
		if (strIns != "0" || strIns != "." || strIns != "") {
			lua_pushstring(L, strIns.c_str());
			return 1;
		}
		return 0;
	}
	return 0;
} },
{ "ClearAllChildren", [](lua_State* L)->int {
	Inst* inst = CheckInstance<Inst>(L, 1);
	if (inst) {
		rbxWrapToLua(luaState, inst->InstanceRef);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, "ClearAllChildren");
			rbxlua_pushvalue(luaState, -2);
			rbxlua_pcall(luaState, 1, 0, 0);
		}
		return 1;
	}
	return 0;
} },
	} },
};

int luaIndex(lua_State* L) {
	Inst* inst = CheckInstance<Inst>(L, 1);
	const char* Index = luaL_checkstring(L, 2);
	if (inst) {
		int Ins = inst->InstanceRef;
		std::string InsName(GetName(Ins));
		std::string Class(GetClass(Ins));
		std::string Prop(Index);

		if (Class == "Workspace") {
			if (Prop == "FilteringEnabled") {
				lua_pushboolean(L, (int)GetFilteringEnabled(Workspace));;
				return 1;
			}
			else if (Prop == "CurrentCamera") {
				WrapToLua(L, GetCurrentCamera(Workspace));
				lua_pushvalue(L, -1);
				return 1;
			}
		}
		else if (Class == "Part") {
			rbxWrapToLua(luaState, Ins);
			rbxlua_getfield(luaState, -1, Prop.c_str());
			const char* ret = rbxlua_tostring(luaState, -1);//*(IntVal_ZeroVal) ^ *(DWORD*)(Ins + 72);
			lua_pushstring(L, ret);
			return 1;
		}
		else if (Class == "Player") {
			if (Prop == "Character") {
				WrapToLua(L, GetCharacterFromPlayer(Ins));
				lua_pushvalue(L, -1);
				return 1;
			}
			else if (Prop == "userId" || Prop == "UserId") {
				lua_pushinteger(L, GetPlayerUserId(Ins));
				return 1;
			}
			else if (Prop == "AccountAge") {
				lua_pushinteger(L, GetAccountAge(Ins));
				return 1;
			}
		}
		else if (Class == "Players") {
			if (Prop == "LocalPlayer" || Prop == "localPlayer") {
				WrapToLua(L, GetLocalPlayer(Ins));
				lua_pushvalue(L, -1);
				return 1;
			}
		}
		else if (Class == "IntValue") {
			if (Prop == "Value") {
				rbxWrapToLua(luaState, Ins);
				rbxlua_getfield(luaState, -1, Prop.c_str());
				double ret = rbxlua_tonumber(luaState, -1);//*(IntVal_ZeroVal) ^ *(DWORD*)(Ins + 72);
				lua_pushnumber(L, ret);
				return 1;
			}
		}
		else if (Class == "NumberValue") {
			if (Prop == "Value") {
				rbxWrapToLua(luaState, Ins);
				rbxlua_getfield(luaState, -1, Prop.c_str());
				if (rbxlua_isstring(luaState, -1)) {
					double ret = rbxlua_tonumber(luaState, -1);//*(IntVal_ZeroVal) ^ *(DWORD*)(Ins + 72);
					lua_pushnumber(L, ret);
					return 1;
				}
			}
		}
		else if (Class == "StringValue") {
			if (Prop == "Value") {
				rbxWrapToLua(luaState, Ins);
				rbxlua_getfield(luaState, -1, Prop.c_str());
				const char* asd = rbxlua_tostring(luaState, -1);//(std::string*)(Ins + 72);
				lua_pushstring(L, asd);
				return 1;
			}
		}
		else if (Class == "BoolValue") {
			if (Prop == "Value") {
				rbxWrapToLua(luaState, Ins);
				rbxlua_getfield(luaState, -1, Prop.c_str());
				bool asd = rbxlua_toboolean(luaState, -1);//*(bool*)(Ins + 72);
				lua_pushboolean(L, asd);
				return 1;
			}
		}
		/*else if (Class == "ObjectValue") {
		if (Prop == "Value") {
		int asd = GetObjectValue(Ins);
		if (asd != 0) {
		WrapToLua(L, asd);
		lua_pushvalue(L, -1);
		return 1;
		}
		lua_pushnil(L);
		return 1;
		}
		}*/
		if (Prop == "Name") {
			lua_pushstring(L, InsName.c_str());
			return 1;
		}
		else if (Prop == "ClassName" || Prop == "className") {
			lua_pushstring(L, Class.c_str());
			return 1;
		}
		else if (Prop == "Parent") {
			WrapToLua(L, GetParent(Ins));
			lua_pushvalue(L, -1);
			return 1;
		}
		else if (Prop == "RobloxLocked") {
			lua_pushboolean(L, GetRobloxLocked(Ins));
			return 1;
		}

		if (ClassFuncs.find(Class) != ClassFuncs.end()) {
			if (ClassFuncs[Class].find(Prop) != ClassFuncs[Class].end()) {
				lua_pushcfunction(L, ClassFuncs[Class][Prop]);
				return 1;
			}
		}

		if (ClassFuncs["1337IsBack"].find(Prop) != ClassFuncs["1337IsBack"].end()) {
			lua_pushcfunction(L, ClassFuncs["1337IsBack"][Prop]);
			return 1;
		}

		int Child = FindFirstChild_PartOf(Ins, Prop);
		if (Child) {
			WrapToLua(L, Child);
			lua_pushvalue(L, -1);
			return 1;
		}

		/*rbxWrapToLua(luaState, Ins);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_getfield(luaState, -1, Prop.c_str());
			if (!rbxlua_isnoneornil(luaState, -1)) {
				const char* asd = rbxlua_tostring(luaState, -1);
				if (strcmp(asd, "nil") != 0) {
					lua_pushstring(L, asd);
				}
				else {
					bool asdf = rbxlua_toboolean(luaState, -1);
					lua_pushboolean(L, asdf);
					//else {
					//	double ret = rbxlua_tonumber(luaState, -1);
					//	lua_pushnumber(L, ret);
					//}
				}
			}
		}
		return 1;*/

		luaL_error(L, "%s is not a valid member of %s", Prop.c_str(), GetName(Ins).c_str());
	}
	return 0;
}

int luaNewIndex(lua_State* L) {
	Inst* inst = CheckInstance<Inst>(L, 1);
	const char* Index = luaL_checkstring(L, 2);
	if (inst) {
		int Ins = inst->InstanceRef;
		std::string Prop(Index);
		std::string Class = GetClass(Ins);
		bool setProp = false;
		if (Class == "Part" || Class == "VehicleSeat" || Class == "TrussPart" || Class == "RightAngleRampPart" || Class == "PyramidPart" || Class == "PrismPart" || Class == "ParallelRampPart" || Class == "MeshPart" || Class == "CornerWedgePart") {
			if (Prop == "Anchored") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				if (val == true) {
					SetAnchored(Ins, 1); //? 1 : 0);
				}
				else {
					SetAnchored(Ins, 0);
				}
				setProp = true;
			}
			else if (Prop == "Transparency") {
				double Trans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Trans);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Reflectance") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Locked") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "CanCollide") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BackParamA") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BackParamB") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BottomParamA") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BottomParamB") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "FrontParamA") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "FrontParamB") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "LeftParamA") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "LeftParamB") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "RightParamA") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "RightParamB") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Elasticity") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Friction") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "LocalTransparencyModifier") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "ReceiveAge") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "ResizeIncrement") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "SpecificGravity") {
				double Reflec = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Reflec);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Material") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BackSurface") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BackSurfaceInput") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BottomSurface") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BottomSurfaceInput") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "FrontSurface") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "FrontSurfaceInput") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "LeftSurface") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "LeftSurfaceInput") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "RightSurface") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "RightSurfaceInput") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "TopSurface") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "TopSurfaceInput") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Shape") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Size") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Position") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "RotVelocity") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Rotation") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Velocity") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "BrickColor" || Prop == "brickColor") {
				Types::BrickColor* LuaBrickColor = Types::CheckBrickColor(L, 3);
				if (LuaBrickColor) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "BrickColor");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushstring(luaState, LuaBrickColor->A);
					rbxlua_pcall(luaState, 1, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}

			if (setProp == false) {
				if (Class == "Part") {
					if (Prop == "FormFactor" || Prop == "formFactor") {
						const char* val = luaL_checkstring(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushstring(luaState, val);
						rbxlua_setfield(luaState, -2, Prop.c_str());
						setProp = true;
					}
				}
			}
		}
		else if (Class == "Lighting") {
			if (Prop == "FogEnd") {
				//int fog = luaL_checkinteger(L, 3);
				//SetFogEnd(Ins, fog);
				int val = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "FogStart") {
				//int fog = luaL_checkinteger(L, 3);
				//SetFogStart(Ins, fog);
				int val = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "FogColor") {
				Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
				if (LuaColor3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Color3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaColor3->X);
					rbxlua_pushnumber(luaState, LuaColor3->Y);
					rbxlua_pushnumber(luaState, LuaColor3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
				else {
					luaL_argerror(L, 3, "table expected");
				}
			}
			else if (Prop == "GlobalShadows") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Outlines") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Brightness") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "GeographicLatitude") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "TimeOfDay") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "Accoutrement" || Class == "Hat") {
			if (Prop == "AttachmentForward") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "AttachmentPoint") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "AttachmentPos") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "AttachmentRight") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "AttachmentUp") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "BlockMesh") {
			if (Prop == "Offset") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Scale") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "VertexColor") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "CylinderkMesh") {
			if (Prop == "Offset") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Scale") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "VertexColor") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "SpecialMesh") {
			if (Prop == "MeshType") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Offset") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Scale") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "VertexColor") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "PointLight") {
			if (Prop == "Brightness") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Range") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Enabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Shadows") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "SpotLight") {
			if (Prop == "Brightness") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Range") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Angle") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Face") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Enabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Shadows") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "SurfaceLight") {
			if (Prop == "Brightness") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Range") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Angle") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Face") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Enabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Shadows") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "ParticleEmitter") {
			if (Prop == "Drag") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "LightEmission") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Rate") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "VelocityInheritance") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "VelocitySpread") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "ZOffset") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Texture") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Enabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "LockedToPart") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Acceleration") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Lifetime") {
				Types::NumberRange* LuaNumberRange = Types::CheckNumberRange(L, 3);
				if (LuaNumberRange) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "NumberRange");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaNumberRange->A);
					rbxlua_pushnumber(luaState, LuaNumberRange->B);
					rbxlua_pcall(luaState, 2, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "RotSpeed") {
				Types::NumberRange* LuaNumberRange = Types::CheckNumberRange(L, 3);
				if (LuaNumberRange) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "NumberRange");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaNumberRange->A);
					rbxlua_pushnumber(luaState, LuaNumberRange->B);
					rbxlua_pcall(luaState, 2, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Rotation") {
				Types::NumberRange* LuaNumberRange = Types::CheckNumberRange(L, 3);
				if (LuaNumberRange) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "NumberRange");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaNumberRange->A);
					rbxlua_pushnumber(luaState, LuaNumberRange->B);
					rbxlua_pcall(luaState, 2, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Speed") {
				Types::NumberRange* LuaNumberRange = Types::CheckNumberRange(L, 3);
				if (LuaNumberRange) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "NumberRange");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaNumberRange->A);
					rbxlua_pushnumber(luaState, LuaNumberRange->B);
					rbxlua_pcall(luaState, 2, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "Smoke") {
			if (Prop == "Opacity") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "RiseVelocity") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, "Size");
				setProp = true;
			}
			else if (Prop == "Size") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, "Size");
				setProp = true;
			}
			else if (Prop == "Enabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Color") {
				Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
				if (LuaColor3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Color3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaColor3->X);
					rbxlua_pushnumber(luaState, LuaColor3->Y);
					rbxlua_pushnumber(luaState, LuaColor3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "Fire") {
			if (Prop == "Heat") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Size" || Prop == "size") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, "Size");
				setProp = true;
			}
			else if (Prop == "Enabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Color") {
				Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
				if (LuaColor3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Color3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaColor3->X);
					rbxlua_pushnumber(luaState, LuaColor3->Y);
					rbxlua_pushnumber(luaState, LuaColor3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "SecondaryColor") {
				Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
				if (LuaColor3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Color3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaColor3->X);
					rbxlua_pushnumber(luaState, LuaColor3->Y);
					rbxlua_pushnumber(luaState, LuaColor3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "Sparkles") {
			if (Prop == "Enabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Color") {
				Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
				if (LuaColor3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Color3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaColor3->X);
					rbxlua_pushnumber(luaState, LuaColor3->Y);
					rbxlua_pushnumber(luaState, LuaColor3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "SparkleColor") {
				Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
				if (LuaColor3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Color3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaColor3->X);
					rbxlua_pushnumber(luaState, LuaColor3->Y);
					rbxlua_pushnumber(luaState, LuaColor3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "Tool") {
			if (Prop == "CanBeDropped") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Enabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "ManualActivationOnly") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "RequiresHandle") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "ToolTip") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "HopperBin") {
			if (Prop == "Activate") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BinType") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "Animation") {
			if (Prop == "AnimationId") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "ShirtGraphic") {
			if (Prop == "Graphic") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "Shirt") {
			if (Prop == "ShirtTemplate") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "Pants") {
			if (Prop == "PantsTemplate") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "CFrameValue") {
			if (Prop == "Value") {
				Types::CFrame* LuaCFrame3 = Types::CheckCFrame(L, 3); Sleep(10);
				if (LuaCFrame3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "CFrame");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaCFrame3->X);
					rbxlua_pushnumber(luaState, LuaCFrame3->Y);
					rbxlua_pushnumber(luaState, LuaCFrame3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "IntValue") {
			if (Prop == "Value") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "NumberValue") {
			if (Prop == "Value") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				//rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, "Value");
				setProp = true;
			}
		}
		else if (Class == "StringValue") {
			if (Prop == "Value") {
				const char* val = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, val);
				rbxlua_setfield(luaState, -2, "Value");
				setProp = true;
			}
		}
		else if (Class == "BoolValue") {
			if (Prop == "Value") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val);
				rbxlua_setfield(luaState, -2, "Value");
				setProp = true;
			}
		}
		else if (Class == "Vector3Value") {
			if (Prop == "Value") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "Humanoid") {
			if (Prop == "Health") {
				int val = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "JumpPower") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "MaxHealth" || Prop == "maxHealth") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, "MaxHealth");
				setProp = true;
			}
			else if (Prop == "HealthDisplayDistance") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "MaxSlopeAngle") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "HipHeight") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "NameDisplayDistance") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "RagdollCriteria") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "WalkSpeed") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "AutoJumpEnabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "AutoRotate") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Jump") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "PlatformStand") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Sit") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "CameraOffset") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "MoveDirection") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "TargetPoint") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "WalkToPoint") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "Player") {
			if (Prop == "CharacterAppearance") {
				const char* CharApp = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, CharApp);
				rbxlua_setfield(luaState, -2, "CharacterAppearance");
				setProp = true;
			}
			else if (Prop == "CanLoadCharacterAppearance") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, "CanLoadCharacterAppearance");
				setProp = true;
			}
			else if (Prop == "Character") {
				Inst* newChar = CheckInstance<Inst>(L, 3);
				SetCharacter(Ins, newChar->InstanceRef);
				setProp = true;
			}
		}
		else if (Class == "Sky") {
			if (Prop == "SkyboxBk") {
				const char* Id = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, Id);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "SkyboxFt") {
				const char* Id = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, Id);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "SkyboxUp") {
				const char* Id = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, Id);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "SkyboxDn") {
				const char* Id = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, Id);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "SkyboxLf") {
				const char* Id = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, Id);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "SkyboxRt") {
				const char* Id = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, Id);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "StarCount") {
				int starCount = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(starCount).c_str());
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "SpawnLocation") {
			if (Prop == "AllowTeamChangeOnTouch") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Enabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Neutral") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Duration") {
				int starCount = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(starCount).c_str());
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "BodyAngularVelocity") {
			if (Prop == "P") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "AngularVelocity") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "MaxTorque" || Prop == "maxTorque") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "BodyForce") {
			if (Prop == "Force" || Prop == "force") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "BodyGyro") {
			if (Prop == "P") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "D") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "MaxTorque" || Prop == "maxTorque") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "CFrame" || Prop == "cframe") {
				Types::CFrame* LuaCFrame3 = Types::CheckCFrame(L, 3); Sleep(10);
				if (LuaCFrame3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "CFrame");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaCFrame3->X);
					rbxlua_pushnumber(luaState, LuaCFrame3->Y);
					rbxlua_pushnumber(luaState, LuaCFrame3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "BodyPosition") {
			if (Prop == "D") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "P") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "MaxForce" || Prop == "maxForce") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Position" || Prop == "position") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "BodyThrust") {
			if (Prop == "Force" || Prop == "force") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Location" || Prop == "location") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "BodyVelocity") {
			if (Prop == "P") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "MaxForce" || Prop == "maxForce") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Velocity" || Prop == "velocity") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "RocketPropulsion") {
			if (Prop == "CartoonFactor") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "MaxSpeed") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "MaxThrust") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "TargetRadius") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "ThrustD") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "ThrustP") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "TurnD") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "TurnP") {
				int val = luaL_checkinteger(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				//rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "TargetOffset") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "MaxTorque") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Target") {
				Inst* newInstance = CheckInstance<Inst>(L, 3);
				rbxWrapToLua(luaState, newInstance->InstanceRef);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushvalue(luaState, -3);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}

		else if (Class == "Sound") {
			if (Prop == "SoundId") {
				const char* Id = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, Id);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Volume") {
				int Volume = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(Volume).c_str());
				rbxlua_setfield(luaState, -2, Prop.c_str());
			}
			else if (Prop == "Pitch") {
				int Pitch = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(Pitch).c_str());
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "MaxDistance") {
				int val = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "MinDistance") {
				int val = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(val).c_str());
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Looped") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
		}
		else if (Class == "Explosion") {
			if (Prop == "ExplosionType") {
				const char* Id = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, Id);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BlastRadius") {
				int BlastRadius = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(BlastRadius).c_str());
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BlastPressure") {
				int BlastPressure = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(BlastPressure).c_str());
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "DestroyJointRadiusPercent") {
				int BlastPressure = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, std::to_string(BlastPressure).c_str());
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Position") {
				Types::Vector3* LuaVec3 = Types::CheckVector3(L, 3);
				if (LuaVec3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Vector3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaVec3->X);
					rbxlua_pushnumber(luaState, LuaVec3->Y);
					rbxlua_pushnumber(luaState, LuaVec3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "TextLabel" || Class == "TextBox" || Class == "TextButton" || Class == "Frame" || Class == "ImageLabel" || Class == "ScrollingFrame" || Class == "ImageButton") {
			if (Prop == "Active") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Visible") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "ClipsDescendants") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Draggable") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "Selectable") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "BackgroundTransparency") {
				double Trans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Trans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "BorderSizePixel") {
				double val = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "Rotation") {
				double val = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "Transparency") {
				double val = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "ZIndex") {
				double val = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "SizeConstraint") {
				const char* newText = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, newText);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "Size") {
				Types::UDim2* LuaUDim2 = Types::CheckUDim2(L, 3);
				if (LuaUDim2) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "UDim2");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaUDim2->A);
					rbxlua_pushnumber(luaState, LuaUDim2->B);
					rbxlua_pushnumber(luaState, LuaUDim2->C);
					rbxlua_pushnumber(luaState, LuaUDim2->D);
					rbxlua_pcall(luaState, 4, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Position") {
				Types::UDim2* LuaUDim2 = Types::CheckUDim2(L, 3);
				if (LuaUDim2) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "UDim2");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaUDim2->A);
					rbxlua_pushnumber(luaState, LuaUDim2->B);
					rbxlua_pushnumber(luaState, LuaUDim2->C);
					rbxlua_pushnumber(luaState, LuaUDim2->D);
					rbxlua_pcall(luaState, 4, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "BackgroundColor3") {
				Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
				if (LuaColor3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Color3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaColor3->X);
					rbxlua_pushnumber(luaState, LuaColor3->Y);
					rbxlua_pushnumber(luaState, LuaColor3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "BorderColor3") {
				Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
				if (LuaColor3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "Color3");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaColor3->X);
					rbxlua_pushnumber(luaState, LuaColor3->Y);
					rbxlua_pushnumber(luaState, LuaColor3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
				else {
					luaL_argerror(L, 3, "table expected");
				}
			}

			if (setProp != true) {
				if (Class == "TextLabel" || Class == "TextBox" || Class == "TextButton") {
					if (Prop == "Text") {
						const char* newText = luaL_checkstring(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushstring(luaState, newText);
						rbxlua_setfield(luaState, -2, Prop.c_str());
						setProp = true;
					}
					else if (Prop == "Font") {
						const char* newText = luaL_checkstring(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushstring(luaState, newText);
						rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
						setProp = true;
					}
					else if (Prop == "FontSize") {
						const char* newText = luaL_checkstring(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushstring(luaState, newText);
						rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
						setProp = true;
					}
					else if (Prop == "TextXAlignment") {
						const char* newText = luaL_checkstring(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushstring(luaState, newText);
						rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
						setProp = true;
					}
					else if (Prop == "TextYAlignment") {
						const char* newText = luaL_checkstring(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushstring(luaState, newText);
						rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
						setProp = true;
					}
					else if (Prop == "FontSize") {
						const char* newText = luaL_checkstring(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushstring(luaState, newText);
						rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
						setProp = true;
					}
					else if (Prop == "TextStrokeTranparency") {
						double val = luaL_checknumber(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushnumber(luaState, val);
						rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
						setProp = true;
					}
					else if (Prop == "TextTransparency") {
						double val = luaL_checknumber(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushnumber(luaState, val);
						rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
						setProp = true;
					}
					else if (Prop == "TextFits") {
						if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
						bool val = lua_toboolean(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushbool(luaState, val ? 1 : 0);
						rbxlua_setfield(luaState, -2, Prop.c_str());
						setProp = true;
					}
					else if (Prop == "TextScaled") {
						if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
						bool val = lua_toboolean(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushbool(luaState, val ? 1 : 0);
						rbxlua_setfield(luaState, -2, Prop.c_str());
						setProp = true;
					}
					else if (Prop == "TextWrapped") {
						if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
						bool val = lua_toboolean(L, 3);
						rbxWrapToLua(luaState, Ins);
						rbxlua_pushbool(luaState, val ? 1 : 0);
						rbxlua_setfield(luaState, -2, Prop.c_str());
						setProp = true;
					}
					else if (Prop == "TextColor3") {
						Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
						if (LuaColor3) {
							rbxWrapToLua(luaState, Ins);
							rbxlua_getglobal(luaState, "Color3");
							rbxlua_getfield(luaState, -1, "new");
							rbxlua_pushnumber(luaState, LuaColor3->X);
							rbxlua_pushnumber(luaState, LuaColor3->Y);
							rbxlua_pushnumber(luaState, LuaColor3->Z);
							rbxlua_pcall(luaState, 3, 1, 0);
							rbxlua_setfield(luaState, -3, Prop.c_str());
							setProp = true;
						}
						else {
							luaL_argerror(L, 3, "table expected");
						}
					}
					else if (Prop == "TextStrokeColor3") {
						Types::Color3* LuaColor3 = Types::CheckColor3(L, 3);
						if (LuaColor3) {
							rbxWrapToLua(luaState, Ins);
							rbxlua_getglobal(luaState, "Color3");
							rbxlua_getfield(luaState, -1, "new");
							rbxlua_pushnumber(luaState, LuaColor3->X);
							rbxlua_pushnumber(luaState, LuaColor3->Y);
							rbxlua_pushnumber(luaState, LuaColor3->Z);
							rbxlua_pcall(luaState, 3, 1, 0);
							rbxlua_setfield(luaState, -3, Prop.c_str());
							setProp = true;
						}
						else {
							luaL_argerror(L, 3, "table expected");
						}
					}
				}
			}
		}
		else if (Class == "HopperBin") {
			if (Prop == "BinType") {
				const char* newText = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, newText);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "Camera") {
			if (Prop == "CameraSubject") {
				Inst* newSubject = CheckInstance<Inst>(L, 3);
				SetCameraSubject(Ins, newSubject->InstanceRef);
				setProp = true;
			}
			else if (Prop == "HeadLocked") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val ? 1 : 0);
				rbxlua_setfield(luaState, -2, Prop.c_str());
				setProp = true;
			}
			else if (Prop == "FieldOfView") {
				double Trans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Trans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "HeadScale") {
				double Trans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Trans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "CFrame") {
				Types::CFrame* LuaCFrame3 = Types::CheckCFrame(L, 3); Sleep(10);
				if (LuaCFrame3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "CFrame");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaCFrame3->X);
					rbxlua_pushnumber(luaState, LuaCFrame3->Y);
					rbxlua_pushnumber(luaState, LuaCFrame3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Focus" || Prop == "focus") {
				Types::CFrame* LuaCFrame3 = Types::CheckCFrame(L, 3); Sleep(10);
				if (LuaCFrame3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "CFrame");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaCFrame3->X);
					rbxlua_pushnumber(luaState, LuaCFrame3->Y);
					rbxlua_pushnumber(luaState, LuaCFrame3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "CoordinateFrame") {
				Types::CFrame* LuaCFrame3 = Types::CheckCFrame(L, 3); Sleep(10);
				if (LuaCFrame3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "CFrame");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaCFrame3->X);
					rbxlua_pushnumber(luaState, LuaCFrame3->Y);
					rbxlua_pushnumber(luaState, LuaCFrame3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
		}
		else if (Class == "Weld") {
			if (Prop == "C0") {
				Types::CFrame* LuaCFrame3 = Types::CheckCFrame(L, 3); Sleep(10);
				if (LuaCFrame3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "CFrame");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaCFrame3->X);
					rbxlua_pushnumber(luaState, LuaCFrame3->Y);
					rbxlua_pushnumber(luaState, LuaCFrame3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "C1") {
				Types::CFrame* LuaCFrame3 = Types::CheckCFrame(L, 3); Sleep(10);
				if (LuaCFrame3) {
					rbxWrapToLua(luaState, Ins);
					rbxlua_getglobal(luaState, "CFrame");
					rbxlua_getfield(luaState, -1, "new");
					rbxlua_pushnumber(luaState, LuaCFrame3->X);
					rbxlua_pushnumber(luaState, LuaCFrame3->Y);
					rbxlua_pushnumber(luaState, LuaCFrame3->Z);
					rbxlua_pcall(luaState, 3, 1, 0);
					rbxlua_setfield(luaState, -3, Prop.c_str());
					setProp = true;
				}
			}
			else if (Prop == "Part0") {
				Inst* newInstance = CheckInstance<Inst>(L, 3);
				if (newInstance) {
					rbxWrapToLua(luaState, newInstance->InstanceRef); Sleep(10);
					rbxWrapToLua(luaState, Ins);
					rbxlua_pushvalue(luaState, -4);
					rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
					setProp = true;
				}
			}
			else if (Prop == "Part1") {
				Inst* newInstance = CheckInstance<Inst>(L, 3);
				if (newInstance) {
					rbxWrapToLua(luaState, newInstance->InstanceRef); Sleep(10);
					rbxWrapToLua(luaState, Ins);
					rbxlua_pushvalue(luaState, -4);
					rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
					setProp = true;
				}
			}
		}
		else if (Class == "SurfaceSelection") {
			if (Prop == "Adornee") {
				Inst* newInstance = CheckInstance<Inst>(L, 3);
				rbxWrapToLua(luaState, newInstance->InstanceRef);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushvalue(luaState, -3);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "SelectionBox") {
			if (Prop == "Adornee") {
				Inst* newInstance = CheckInstance<Inst>(L, 3);
				rbxWrapToLua(luaState, newInstance->InstanceRef);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushvalue(luaState, -3);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "LineThickness") {
				double Trans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Trans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "SurfaceTransparency") {
				double Trans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Trans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "SelectionSphere") {
			if (Prop == "Adornee") {
				Inst* newInstance = CheckInstance<Inst>(L, 3);
				rbxWrapToLua(luaState, newInstance->InstanceRef);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushvalue(luaState, -3);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "SurfaceTransparency") {
				double Trans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Trans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "BillboardGui") {
			if (Prop == "Adornee") {
				Inst* newInstance = CheckInstance<Inst>(L, 3);
				rbxWrapToLua(luaState, newInstance->InstanceRef);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushvalue(luaState, -3);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "SurfaceGui") {
			if (Prop == "Adornee") {
				Inst* newInstance = CheckInstance<Inst>(L, 3);
				rbxWrapToLua(luaState, newInstance->InstanceRef);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushvalue(luaState, -3);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "Hint" || Class == "Message") {
			if (Prop == "Text") {
				const char* newText = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, newText);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "Decal") {
			if (Prop == "Texture") {
				const char* newText = luaL_checkstring(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushstring(luaState, newText);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "Transparency") {
				double Trans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Trans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "LocalTransparencyModifier") {
				double LocalTrans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, LocalTrans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "Texture") {
			if (Prop == "StudsPerTileU") {
				double Trans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, Trans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
			else if (Prop == "StudsPerTileV") {
				double LocalTrans = luaL_checknumber(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushnumber(luaState, LocalTrans);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "LocalScript") {
			if (Prop == "Disabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}
		else if (Class == "ScriptContext") {
			if (Prop == "ScriptsDisabled") {
				if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
				bool val = lua_toboolean(L, 3);
				rbxWrapToLua(luaState, Ins);
				rbxlua_pushbool(luaState, val);
				rbxlua_setfield(luaState, -2, Prop.c_str()); Sleep(10);
				setProp = true;
			}
		}

		//props that work on any class

		if (Prop == "Name") {
			const char* newName = luaL_checkstring(L, 3);
			//int* t = (int*)rbxlua_newuserdata(luaState, 8);
			//*t = Ins;
			rbxWrapToLua(luaState, Ins);
			rbxlua_pushstring(luaState, newName);
			rbxlua_setfield(luaState, -2, "Name"); Sleep(1);
			setProp = true;
		}
		else if (Prop == "Parent") {
			Inst* newParent = CheckInstance<Inst>(L, 3);
			//rbxWrapToLua(luaState, newParent->InstanceRef);
			//rbxlua_setfield(luaState, -3, "Parent"); Sleep(1);
			setParent(Ins, newParent->InstanceRef); Sleep(1);
			setProp = true;
		}
		else if (Prop == "Archivable" || Prop == "archivable") {
			if (!lua_isboolean(L, 3)) luaL_argerror(L, 3, "boolean expected");
			bool val = lua_toboolean(L, 3);
			rbxWrapToLua(luaState, Ins);
			rbxlua_pushbool(luaState, val ? 1 : 0);
			rbxlua_setfield(luaState, -2, "Archivable"); Sleep(1);
			setProp = true;
		}
		Sleep(10);
		if (setProp != true) {
			luaL_error(L, "%s is not a valid member of %s", Prop, GetName(Ins).c_str());
		}
	}
	return 0;
}

int luaEquals(lua_State* L) {
	Inst* Inst1 = CheckInstance<Inst>(L, 1);
	Inst* Inst2 = CheckInstance<Inst>(L, 2);
	if (Inst1 != nullptr && Inst2 != nullptr) {
		lua_pushboolean(L, Inst1->InstanceRef == Inst2->InstanceRef);
		return 1;
	}
	lua_pushboolean(L, 0);
	return 1;
}

int CreateGlobalMetatable(lua_State* L) {
	luaL_newmetatable(L, "ObjectMetatable");
	lua_pushstring(L, "This metatable is locked.");
	lua_setfield(L, -2, "__metatable");
	lua_pushcfunction(L, luaToString);
	lua_setfield(L, -2, "__tostring");
	lua_pushcfunction(L, luaEquals);
	lua_setfield(L, -2, "__eq");
	lua_pushcfunction(L, luaNewIndex);
	lua_setfield(L, -2, "__newindex");
	lua_pushcfunction(L, luaIndex);
	lua_setfield(L, -2, "__index");
	return 0;
}
 
int InstanceNew(lua_State* L) {
	int newParent = 0;
	int indexMax = -1;
	int Ins;
	const char* Class = luaL_checkstring(L, 1);
	if (lua_gettop(L) == 2) {
		Inst* newPar = CheckInstance<Inst>(L, 2);
		rbxlua_getglobal(luaState, "Instance");
		rbxlua_getfield(luaState, -1, "new");
		rbxlua_pushstring(luaState, Class);
		//rbxlua_pushvalue(luaState, -4);
		rbxlua_pcall(luaState, 1, 1, 0); Sleep(2);

		if (!rbxlua_isnil(luaState, -1)) {
			Ins = rbxlua_touserdata(luaState, -1);
			if (Ins != 0) {
				setParent(Ins, newPar->InstanceRef);
			}
			/*rbxWrapToLua(luaState, newPar->InstanceRef);
			if (!rbxlua_isnil(luaState, -1)) {
				//rbxlua_pushvalue(luaState, -1);
				rbxlua_setfield(luaState, -3, "Parent"); Sleep(20);
				//rbxlua_pcall(luaState, 0, 0, 0); 
			}
			else if (!rbxlua_isnil(luaState, -2)) {
				rbxlua_setfield(luaState, -4, "Parent"); Sleep(20);
			}*/
		}
		indexMax = -2;
	}
	else {
		rbxlua_getglobal(luaState, "Instance");
		rbxlua_getfield(luaState, -1, "new");
		rbxlua_pushstring(luaState, Class);
		//rbxlua_pushvalue(luaState, -4);
		rbxlua_pcall(luaState, 1, 1, 0);
		if (!rbxlua_isnil(luaState, -1)) {
			Ins = rbxlua_touserdata(luaState, -1);
		}
	}
	if (!rbxlua_isnil(luaState, indexMax)) {
		if (Ins != 0) {
			WrapToLua(L, Ins);
			lua_pushvalue(L, -1);
		}
	}
	return 1;
}

int Vector3New(lua_State* L) {
	double X = luaL_checknumber(L, 1);
	double Y = luaL_checknumber(L, 2);
	double Z = luaL_checknumber(L, 3);

	Types::Vector3* LuaVec3 = new Types::Vector3(X, Y, Z);
	LuaVec3->WrapLua(L);
	return 1;
}

int Color3New(lua_State* L) {
	double X = luaL_checknumber(L, 1);
	double Y = luaL_checknumber(L, 2);
	double Z = luaL_checknumber(L, 3);

	Types::Color3* LuaColor3 = new Types::Color3(X, Y, Z);
	LuaColor3->WrapLua(L);
	return 1;
}

int CFrameNew(lua_State* L) {
	double X = luaL_checknumber(L, 1);
	double Y = luaL_checknumber(L, 2);
	double Z = luaL_checknumber(L, 3);

	Types::CFrame* LuaColor3 = new Types::CFrame(X, Y, Z);
	LuaColor3->WrapLua(L);
	return 1;
}

int UDim2New(lua_State* L) {
	double A = luaL_checknumber(L, 1);
	double B = luaL_checknumber(L, 2);
	double C = luaL_checknumber(L, 3);
	double D = luaL_checknumber(L, 4);

	Types::UDim2* LuaUDim2 = new Types::UDim2(A, B, C, D);
	LuaUDim2->WrapLua(L);
	return 1;
}

int NumberRangeNew(lua_State* L) {
	double A = luaL_checknumber(L, 1);
	double B = luaL_checknumber(L, 2);

	Types::NumberRange* LuaNumberRange = new Types::NumberRange(A, B);
	LuaNumberRange->WrapLua(L);
	return 1;
}

int BrickColorNew(lua_State* L) {
	const char* A = luaL_checkstring(L, 1);
	//double A = luaL_checknumber(L, 1);
	//double B = luaL_checknumber(L, 2);

	rbxlua_getglobal(luaState, "BrickColor");
	rbxlua_getfield(luaState, -1, "new");
	rbxlua_pushstring(luaState, A);
	rbxlua_pcall(luaState, 1, 1, 0);
	//Types::BrickColor* LuaBrickColor = new Types::BrickColor(A);
	//LuaBrickColor->WrapLua(L);
	return 1;
}

lua_State* SetupLuaState(lua_State* L) {

	luaL_openlibs(L);

	lua_pushcfunction(L, LuaConsolePrint);
	lua_setglobal(L, "printconsole");

	lua_pushcfunction(L, LuaPrint);
	lua_setglobal(L, "print");

	lua_pushcfunction(L, LuaWarn);
	lua_setglobal(L, "warn");

	lua_pushcfunction(L, LuaError);
	lua_setglobal(L, "error");

	//lua_pushcfunction(L, LuaExecuteCommand);
	//lua_setglobal(L, "execute");

	lua_pushcfunction(L, luaWait);
	lua_setfield(L, -10002, "wait");

	lua_pushcfunction(L, luaSpawn);
	lua_setfield(L, -10002, "spawn");
	lua_getfield(L, -10002, "spawn");
	lua_setfield(L, -10002, "Spawn");

	lua_pushcfunction(L, luaDelay);
	lua_setfield(L, -10002, "delay");
	lua_getfield(L, -10002, "delay");
	lua_setfield(L, -10002, "Delay");

	//lua_pushcfunction(L, LuaRbxTime);
	//lua_setglobal(L, "time");

	lua_pushcfunction(L, LuaCurrentEpoch);
	lua_setglobal(L, "tick");

	//

	//

	//lua_newtable(L);
	//
	//lua_pushcfunction(L, XYZHttpGet);
	//lua_setfield(L, -2, "get");
	//
	//lua_setglobal(L, "Http");

	//

	lua_newtable(L);

	lua_pushcfunction(L, InstanceNew);
	lua_setfield(L, -2, "new");

	lua_setglobal(L, "Instance");

	//

	//lua_pushnil(L);
	//lua_setglobal(L, "debug");

	CreateGlobalMetatable(L);
	WrapToLua(L, DataModel);
	lua_setglobal(L, "Game");
	lua_getfield(L, -10002, "Game");
	lua_setglobal(L, "game");
	WrapToLua(L, Workspace);
	lua_setglobal(L, "Workspace");
	lua_getfield(L, -10002, "Workspace");
	lua_setglobal(L, "workspace");

	Types::Vector3::RegisterLua(L);

	lua_newtable(L);

	lua_pushcfunction(L, Vector3New);
	lua_setfield(L, -2, "new");

	lua_setglobal(L, "Vector3");

	//

	Types::Color3::RegisterLua(L);

	lua_newtable(L);

	lua_pushcfunction(L, Color3New);
	lua_setfield(L, -2, "new");

	lua_setglobal(L, "Color3");

	//

	Types::UDim2::RegisterLua(L);

	lua_newtable(L);

	lua_pushcfunction(L, UDim2New);
	lua_setfield(L, -2, "new");

	lua_setglobal(L, "UDim2");

	//

	Types::NumberRange::RegisterLua(L);

	lua_newtable(L);

	lua_pushcfunction(L, NumberRangeNew);
	lua_setfield(L, -2, "new");

	lua_setglobal(L, "NumberRange");

	//

	Types::CFrame::RegisterLua(L);

	lua_newtable(L);

	lua_pushcfunction(L, CFrameNew);
	lua_setfield(L, -2, "new");

	lua_setglobal(L, "CFrame");

	return L;
}

int WrapToLua(lua_State* L, int InstRef) {
	Inst* InstC;
	if (InstanceMap.find(InstRef) != InstanceMap.end()) {
		InstC = InstanceMap[InstRef];
	}
	else {
		InstC = new Inst();
		InstC->InstanceRef = InstRef;
		InstanceMap[InstRef] = InstC;
	}

	Inst** userdata = (Inst**)lua_newuserdata(L, sizeof(Inst));
	*userdata = InstC;
	luaL_getmetatable(L, "ObjectMetatable");
	lua_setmetatable(L, -2);
	return 1;
}
//game.StarterGui:SetCoreGuiEnabled("All",false)
int rbxWrapToLua(DWORD luaState, int InstRef) {
	int* t = (int*)rbxlua_newuserdata(luaState, 8);
	*t = InstRef;
	rbxlua_getfield(luaState, rbxlua_REGISTRYINDEX, "Object");
	if (!rbxlua_isnil(luaState, -1) && !rbxlua_isnil(luaState, -2)) {
		rbxlua_setmetatable(luaState, -2);
		if (!rbxlua_isnil(luaState, -1)) {
			rbxlua_pushvalue(luaState, -1);
		}
		else {
			rbxlua_pushnil(luaState);
		}
	}
	else {
		rbxlua_pushnil(luaState);
	}
	return 1;
}

/**/

void LuaExecuteString(std::string Source) {
	if (XYZ_State == nullptr) {
		XYZ_State = luaL_newstate();
		luaL_openlibs(XYZ_State);
		SetupLuaState(XYZ_State);
	}

	int ret = luaL_dostring(XYZ_State, Source.c_str());
	if (ret) {
		const char* err = lua_tostring(XYZ_State, -1);
		std::string message = std::string("\r\nLua Error:") + std::string(err);
		ConsoleOutput(message);
	}
}

/*1337IsBack*/